package WebFlow;

import WebFlow.event.*;
import org.omg.CORBA.*;
import java.util.*;

//BeanContextChild  
public class BeanContextChildSupport implements BeanContextChildOperations,
				BeanContextServicesListenerOperations
{ 
    
	 /**
     * construct a BeanContextChildSupport where this class has been 
     * subclassed in order to implement the JavaBean component itself.
     */
    //If isProxy is true , this child is proxy, real object otherwise
    public BeanContextChildSupport(org.omg.CORBA.Object peer)
				 throws NullPointerException
    {
	isProxy_ = false;
        beanContextChildPeer = peer; //(bcc != null) ? bcc : this;
        WebFlowContextPeer = peer;
	pcSupport = new PropertyChangeSupport(beanContextChildPeer, this);
	vcSupport = new VetoableChangeSupport(beanContextChildPeer, this);
	
	//If beanContext is null, it is outermost beanContext which 
	//represent the actual webflow server
        beanContext = null;	
        orb_ = null;	
	serverFlag =false;
    }

 
  public void setAsServer()
  {
    serverFlag = true;
  }

  public boolean isWFServer()
  {
    return serverFlag;
  }

public void changeImpl(String objName)
    {

    }

  //this method will catched by proxy which will remove this object
  //and proxy itself
public void removeMyself()
  {
    System.out.println("BCS:removeMyself: entered");  
    org.omg.CORBA.Object peer,parent;
    peer = getMyProxy(); //getBeanContextChildPeer();
    parent = getBeanContext();
    WebFlowContext wfc = WebFlowContextHelper.narrow(parent);
        
    //This object is user module
    System.out.println("BCS:removeMyself: User Module Object");
    wfc.removeModule(peer);
    
  }


public org.omg.CORBA.Object[] pull()
{
	return (pcSupport.pull());
}

public void setObjectID(String id)
    {
	objectId = id;
    }

public String getObjectID()
    {
	//System.out.println("BeanCCP:getObjectID :"+objectId);
	return objectId;
    }

public void setMyProxy(org.omg.CORBA.Object obj)
    {
	//System.out.println("BeanContexChildSupport : setting proxy for : "+objectId+" par:"+obj);
      myProxy = obj;
    }
   
  public  org.omg.CORBA.Object getMyProxy()
    {
      return myProxy;
    }

    public void setOrb(org.omg.CORBA.ORB orb)
	{
	    orb_ = orb;
	}

	public void setAsProxy(boolean isProxy )
	{
		isProxy_ = isProxy;	
	}

	public boolean IsChildProxy()
	{
		return isProxy_;
	}

	public void destroy()
	{
	    System.out.println("BeanCContextSSupport:"+getObjectID()+ 
                          "WAS destroy called..");
	  
	    orb_.disconnect(beanContextChildPeer);

	}

	/**
	 * setBeanContextChildPeer
	 */
	 //public void setBeanContextChildPeer(BeanContextChild bcc)
     public void setBeanContextChildPeer(org.omg.CORBA.Object bcc)
			throws NullPointerException
	 {
		beanContextChildPeer = bcc; 

		pcSupport = new PropertyChangeSupport(beanContextChildPeer, this);
		vcSupport = new VetoableChangeSupport(beanContextChildPeer, this);
	 }


    /**
     * setBeanContext
     */

    //public synchronized void setBeanContext(BeanContext bc) 
	public synchronized void setBeanContext(org.omg.CORBA.Object bc) 
	            throws WebFlow.event.PropertyVetoException 
	{
	  //System.out.println("BeanContextChild:setBeanContext :entered");

		if (bc == beanContext) return;

		//BeanContext oldValue = beanContext;
		//BeanContext newValue = bc;

		org.omg.CORBA.Object oldValue = beanContext;
		org.omg.CORBA.Object newValue = bc;  

		if (!rejectedSetBCOnce) {
		    if (rejectedSetBCOnce = !validatePendingSetBeanContext(bc)) {
			throw new PropertyVetoException(
				"setBeanContext() change rejected:",
				new PropertyChangeEventImpl(beanContextChildPeer, 
							"beanContext", oldValue, newValue)
				);
			}

			try {
			    fireVetoableChange("beanContext", oldValue, newValue);
			    //System.out.println("setBeanContext : after fireVetoableChange");
			} catch (PropertyVetoException pve) {
			    rejectedSetBCOnce = true;
			    throw pve; // re-throw
			}
		}

		if (beanContext != null) releaseBeanContextResources();

		beanContext       = newValue;
		rejectedSetBCOnce = false;
	       
		//System.out.println("setBeanContext : before firePropertyChange");
		firePropertyChange("beanContext", oldValue, newValue);

		if (beanContext != null) initializeBeanContextResources();
		//System.out.println("BeanContextChild:setBeanContext :returned");
    }

    /**
     * @returns the current BeanContext associated with the JavaBean
     */
    //public synchronized BeanContext getBeanContext() { return beanContext; }
    public synchronized org.omg.CORBA.Object getBeanContext() {
	return beanContext;
    }

    /**
     * add a property change listener
     */

    public void addPropertyChangeListener(String name, org.omg.CORBA.Object pcl) {
        pcSupport.addPropertyChangeListener(name, pcl);
    }

    
    public void addPropertyChangeListener(org.omg.CORBA.Object pcl) {
		pcSupport.addPropertyChangeListener(pcl);
    }

    /**
     * remove a property change listener
     */

    public void removePropertyChangeListener(String name,  org.omg.CORBA.Object pcl) {
	pcSupport.removePropertyChangeListener(name, pcl);
    }

    public void removePropertyChangeListener(org.omg.CORBA.Object pcl) {
		pcSupport.removePropertyChangeListener(pcl);
    }

    /**
     * add a vetoable change listener
     */

    public void addVetoableChangeListener(String name,org.omg.CORBA.Object  vcl)
    {
	try{
	    vcSupport.addVetoableChangeListener(name, vcl);
	}catch(WebFlow.NullPointerException ex){
	    System.out.println("Got NullPointerException :"+ex);
	}

    }


    /**
     * remove a vetoable change listener
     */ 
   
    public void removeVetoableChangeListener(String name, org.omg.CORBA.Object vcl) {
	vcSupport.removeVetoableChangeListener(name, vcl);
    }

    /**
     * a service provided by the nesting BeanContext has been revoked.
     * 
     * subclasses may override this method in order to implement their own
     * behaviors 
     */
    
    public void serviceRevoked(BeanContextServiceRevokedEvent bcsre) 
	throws IllegalArgumentException	{ }
    

    /**
     * a new service is available from the nesting BeanContext.
     * 
     * subclasses may override this method in order to implement their own
     * behaviors 
     */

    public void serviceAvailable(BeanContextServiceAvailableEvent bcsae)
	throws IllegalArgumentException { }

    
    /**
     * @return the BeanContextChild peer of this class
     */

    //public BeanContextChild getBeanContextChildPeer() { return beanContextChildPeer; }
    public org.omg.CORBA.Object getBeanContextChildPeer() {
	  return beanContextChildPeer;
	}
    
	/**
     * @return true if this class is a delegate of another
     */

    public boolean isDelegated() { return !this.equals(beanContextChildPeer); }

    /**
     * fires a propertyChange Event
     */

  public void fireEvent(String eventMethod, org.omg.CORBA.Object evt)
    {
      pcSupport.fireEvent(eventMethod, evt);
    }
  


    public void firePropertyChange(String name, org.omg.CORBA.Object oldValue, 
		org.omg.CORBA.Object newValue) 
    {
	name = "propertyChange"+"/"+name;
        pcSupport.firePropertyChange(name, oldValue, newValue);
    }

    public void firePropertyChange(String name, String oldValue, 
		String  newValue) 
   {
        name = "propertyChange/"+name;
   	pcSupport.firePropertyChange(name, oldValue, newValue);
    }

        
    /**
     * fires a vetoableChange Event
     */

    public void fireVetoableChange(String name, org.omg.CORBA.Object oldValue,
				 org.omg.CORBA.Object newValue) throws PropertyVetoException 
   {
        name = "vetoablePropertyChange/"+name;
	vcSupport.fireVetoableChange(name, oldValue, newValue);
    }

     public void fireVetoableChange(String name, String oldValue,String  newValue) 
       throws PropertyVetoException 
   {
        name = "vetoablePropertyChange/"+name;
	vcSupport.fireVetoableChange(name, oldValue, newValue);
    }

    /**
     * called from setBeanContext to validate (or otherwise) the
     * pending change in the nesting BeanContext property value.
     *
     * returning false will cause setBeanContext to throw
     * PropertyVetoException.
     */

    //public boolean validatePendingSetBeanContext(BeanContext newValue) {
	public boolean validatePendingSetBeanContext(org.omg.CORBA.Object newValue) {
	return true;
    }

    /**
     * This method may be overridden by subclasses to provide their own
     * release behaviors. When invoked any resources held by this instance
     * obtained from its current BeanContext property should be released
     * since the object is no longer nested within that BeanContext.
     */

    protected  void releaseBeanContextResources() {
	// do nothing
    }

    /**
     * This method may be overridden by subclasses to provide their own
     * initialization behaviors. When invoked any resources requried by the
     * BeanContextChild should be obtained from the current BeanContext.
     */

    protected void initializeBeanContextResources() {
	// do nothing
    }

    /**
     * Write the persistence state of the object.
     */

    /* TO OD LIST
	private void writeObject(ObjectOutputStream oos) throws IOException {
    */
	/*
	 * dont serialize if we are delegated and the delegator isnt also
	 * serializable.
	 */
    /*
	if (!equals(beanContextChildPeer) && !(beanContextChildPeer instanceof Serializable))
	    throw new IOException("BeanContextChildSupport beanContextChildPeer not Serializable");

	else 
            oos.defaultWriteObject();
	    
    }
     */

    /**
     * Restore a persistent object, must wait for subsequent setBeanContext()
     * to fully restore any resources obtained from the new nesting 
     * BeanContext
     */

    /* TO DO LIST
    private void readObject(ObjectInputStream ois) throws IOException, ClassNotFoundException {
	ois.defaultReadObject();
    }
    */

    /*
     * fields
     */
    
    boolean serverFlag;
    private String objectId;
    private org.omg.CORBA.Object myProxy;
    private boolean isProxy_;
     
    //public    BeanContextChild beanContextChildPeer;
    public    org.omg.CORBA.Object beanContextChildPeer;
    public    org.omg.CORBA.Object WebFlowContextPeer ;

    protected PropertyChangeSupport pcSupport;
    protected VetoableChangeSupport vcSupport;

    //protected transient BeanContext	      beanContext;
    protected transient org.omg.CORBA.Object	      beanContext;
    protected transient boolean     	      rejectedSetBCOnce;
    protected boolean      isDeleted;
    org.omg.CORBA.ORB orb_;

}
