
package WebFlow.event;
import WebFlow.*;

public class BeanContextEventImpl implements BeanContextEventOperations
{

    /**
     * Construct a BeanContextEvent
     *
     * @param bc	The BeanContext source
     */

    public BeanContextEventImpl(org.omg.CORBA.Object bc) 
		throws WebFlow.IllegalArgumentException
	{
	 
	  if (bc == null)
	    throw new WebFlow.IllegalArgumentException("null source");

      this.source = bc;


    }

    public org.omg.CORBA.Object getSource()
	{
		return source;
    }
    /**
     *
     */

    public BeanContext getBeanContext() { return (BeanContext)getSource(); }

    /**
     * @param bc Set the BeanContext that last propagated this BeanContextEvent
     */

    public synchronized void setPropagatedFrom(BeanContext bc) {
		propagatedFrom = bc;
    }

    /**
     * @param bc The BeanContext that last propagated this BeanContextEvent
     */

    public synchronized BeanContext getPropagatedFrom() {
	return propagatedFrom;
    }

    /**
     * @return is the BeanContextEvent propagated?
     */

    public synchronized boolean isPropagated() {
	return propagatedFrom != null;
    }

    /*
     * fields
     */

    protected BeanContext propagatedFrom;
	/**
     * The object on which the Event initially occurred.
     */
    protected transient org.omg.CORBA.Object  source;

}
