package WebFlow.event;
import WebFlow.*;
import java.util.*;

public class BeanContextMembershipEventImpl extends BeanContextEventImpl
	implements  BeanContextMembershipEventOperations
{

    

    /**
     * Construct a BeanContextMembershipEvent
     *
     * @param bc	The BeanContext source
     * @param changes	The Children effected
     */

    public BeanContextMembershipEventImpl(org.omg.CORBA.Object bc, 
					  org.omg.CORBA.Object[] changes) 
	throws WebFlow.IllegalArgumentException 
	{
	    super(bc);
	    //children = (WebFlow.Collection)(new BeanContextSupport(bc)Arrays.asList(changes)); */
	    children = new org.omg.CORBA.Object[changes.length];
	}


    /**
     * how many children are effected by the notification
     */

    public int size() { return children.length; }

    /**
     * @return is the child specified effected by the event?
     */

    public boolean contains(org.omg.CORBA.Object child) {
	    for (int k=0;k<children.length;k++)
		  if (child._is_equivalent(children[k]))
		    return true;
		return false;
    }

    /**
     * @return the array of children effected
     */

    public org.omg.CORBA.Object[] toArray() { return children; }

    
    /*
     * fields
     */

    protected org.omg.CORBA.Object []children;
}
