
package WebFlow.event;
import WebFlow.*;

public class BeanContextServiceAvailableEventImpl extends BeanContextEventImpl
 implements  BeanContextServiceAvailableEventOperations
 {

    /**
     * construct a BeanContextServiceEvent
     */

    public BeanContextServiceAvailableEventImpl(BeanContextServices bcs, 
		String sc) throws WebFlow.IllegalArgumentException
	{
		super((BeanContext)bcs);
		serviceClass = sc;
    }

    /**
     * get the source as a reference of type BeanContextServices
     */

    public BeanContextServices getSourceAsBeanContextServices() {
	return (BeanContextServices)getBeanContext();
    }

    /**
     * get the service class that is the subject of this notification
     */

    public String getServiceClass() { return serviceClass; }

    /**
     * @return the current selectors available from the service
     */

    public Iterator getCurrentServiceSelectors() {
    	return ((BeanContextServices)getSource()).getCurrentServiceSelectors(serviceClass);
    }

    /*
     * fields
     */

    protected String			 serviceClass;
}
