package WebFlow.event;
import WebFlow.*;

public class BeanContextServiceRevokedEventImpl extends BeanContextEventImpl
implements  BeanContextServiceRevokedEventOperations{

    /**
     * construct a BeanContextServiceEvent
     */

    public BeanContextServiceRevokedEventImpl(BeanContextServices bcs, 
					String  sc, boolean invalidate) 
					throws WebFlow.IllegalArgumentException

	{
	  super((BeanContext)bcs);

	  serviceClass    = sc;
	  invalidateRefs  = invalidate;
    }

    /**
     * get the source as a reference of type BeanContextServices
     */

    public BeanContextServices getSourceAsBeanContextServices() {
	return (BeanContextServices)getBeanContext();
    }

    /**
     * get the service class that is the subject of this notification
     */

    public String getServiceClass() { return serviceClass; }

    /**
     * test service equality
     */

    public boolean isServiceClass(String service) {
	return serviceClass.equals(service);
    }

    /**
     * true if current service references are now invalidated and unusable.
     */

    public boolean isCurrentServiceInvalidNow() { return invalidateRefs; }

    /**
     * fields
     */

    protected String			 serviceClass;
    private   boolean			 invalidateRefs;
}
