package WebFlow;

import java.util.*;
import WebFlow.event.*;
 
public class  BeanContextSupport extends BeanContextChildSupport
       implements BeanContextOperations
  {
		  

    /**
     * <p>
     * Construct a BeanContextSupport instance
     * </p>
     *
     * @param peer	The peer BeanContext we are supplying an implementation for, if null the this object is its own peer
     * @param lcle	The current Locale for this BeanContext.
     * @param dtime	The initial state, true if in design mode, false if runtime.
     * @param visible	The initial visibility.
     * 
     */

        
	//public BeanContextSupport(BeanContext peer)
	public BeanContextSupport(org.omg.CORBA.Object peer, org.omg.CORBA.ORB orb)

	throws NullPointerException
    {
		super(peer);
		super.setOrb(orb);
		super.setAsProxy(false);
		initialize();
		WebFlowContextPeer = peer; 
	 }

	 
    /**
     * @return the instance of BeanContext this object is providing 
	 * the implementation for.
     */
 
    public org.omg.CORBA.Object getBeanContextPeer() 
	{ 
	   return getBeanContextChildPeer(); 
    }

    /**
     * <p>
     * The instantiateChild method is a convenience hook in BeanContext to simplify
     * the task of instantiating a Bean, nested, into a BeanContext.
     * </p>
     * <p>
     * The semantics of the beanName parameter are defined by java.beans.Beans.instantate.
     * </p>
     *
     * @param beanName the name of the Bean to instantiate within this BeanContext
     */
      
    /* TO DO LIST */
    public org.omg.CORBA.Object instantiateChild(String beanName)
	{
		org.omg.CORBA.Object bc = getBeanContextPeer();

		/*return Beans.instantiate(bc.getClass().getClassLoader(), beanName, bc); */
         return null;
    }

	/* TO DO LIST */
	public int _hashCode()
	{
		return 1;
	}

	public boolean _equals(org.omg.CORBA.Object obj)
	{
		return true;
	}

    /**
     * @return number of children
     */

    public int size() {
	synchronized(children) {
	    return children.size();
	}
    }

    /**
     * @return if there are not children
     */

    public boolean isEmpty() {
	synchronized(children) {
	    return children.isEmpty();
	}
    }

    /**
     * @return if this object is a child
     */

    public boolean contains(org.omg.CORBA.Object o) 
	{
	  synchronized(children) {
	    return children.containsKey(o);
	  }
    }

    /**
     * @return if this object is a child
     */

    public boolean contains(String objectID ) 
	{
	  synchronized(children) {
	    return children.containsKey(objectID);
	  }
    }

    
    /**
     * @return the iterator
     */

    public Iterator iterator() {
	synchronized(children) {
	  org.omg.CORBA.Object[] items = toArray();
	  return new BCSIterator(items);
	  //return new BCSIterator(children.keySet().iterator());
	}
    }

    /**
     * @return an array of children
     */

    public org.omg.CORBA.Object[] toArray() {
      org.omg.CORBA.Object childNode = null;

      myHashMap targets = (myHashMap) children.clone();	  
      java.util.Iterator iter = targets.entrySet().iterator();
      int nelem = targets.size();
      org.omg.CORBA.Object []elist=new org.omg.CORBA.Object[nelem];
      int k=0;
      while (iter.hasNext()) {
	
	  Map.Entry entry     = (Map.Entry)iter.next();
	  String childID      = (String)entry.getKey();//Child Object
	  BCSChild bcsChild   = (BCSChild)entry.getValue(); //BCSChildchild value
	  childNode           = (org.omg.CORBA.Object)bcsChild.getChild(); 
	  elist[k++] = childNode;
	  System.out.println("This Context Added:"+childID);
      }
      return elist;

      /*
      synchronized(children) {
	return (org.omg.CORBA.Object[])(children.keySet().toArray());
      }
      */
    }

    /**
     * @return an array of children
     */

    public org.omg.CORBA.Object[] toArrayInList(org.omg.CORBA.Object[] arry) {
	synchronized(children) {
	    return (org.omg.CORBA.Object[])(children.keySet().toArray(arry));
	}
    }


    /************************************************************************/

    /**
     * protected final subclass that encapsulates an iterator but implements
     * a noop remove() method.
     */

    protected static final class BCSIterator extends _IteratorImplBase {
	BCSIterator(java.util.Iterator i) { super(); src = i;}
      BCSIterator(org.omg.CORBA.Object objs[]){items=objs;indx=0;}
      //BCSIterator(WebFlow.Iterator i) { super(); src=null; p_src = i; }

	public boolean hasNext() { return indx < items.length?true:false;};
                                          //src.hasNext(); }
	public org.omg.CORBA.Object  next()    
	{ 
	  return items[indx++]; //(org.omg.CORBA.Object)src.next();  
	}
	public void    remove()  { /* do nothing */      }

	private java.util.Iterator src;
	org.omg.CORBA.Object []items;
        int indx;
    }

    /************************************************************************/

    /*
     * protected nested class containing per child information, an instance
     * of which is associated with each child in the "children" hashtable.
     * subclasses can extend this class to include their own per-child state.
     *
     * Note that this 'value' is serialized with the corresponding child 'key'
     * when the BeanContextSupport is serialized.
     */

    protected class BCSChild  {
	BCSChild(org.omg.CORBA.Object bcc, org.omg.CORBA.Object peer) {
	    super();
   	    child     = bcc;
	    proxyPeer = peer;
	    childID = null;
	}
    
	BCSChild(org.omg.CORBA.Object bcc, org.omg.CORBA.Object peer, String ID) {
	    super();
	    child     = bcc;
	    proxyPeer = peer;
	    childID = ID;
	    deletePending = false;
	    System.out.println("Creating new BCSChild:childID:"+childID);
	}

	org.omg.CORBA.Object  getChild()        { return child; }

	void    setRemovePending(boolean v) { removePending = v; }
        void    setDeletePending(boolean v) { deletePending = v; }

	boolean isRemovePending()           { return removePending; }
        boolean isDeletePending()           { return deletePending; }

        boolean isProxyPeer()		    { return proxyPeer != null; }

	org.omg.CORBA.Object getProxyPeer()		    { return proxyPeer; }

	String getID(){return childID;}
	/*
	 * fields
	 */

    private       String                 childID;
	private		  org.omg.CORBA.Object   child;
	private       org.omg.CORBA.Object  proxyPeer;
   
	private transient boolean  removePending; 
       private  boolean  deletePending; 
    }

    /**
     * <p>
     * Subclasses can override this method to insert their own subclass
     * of Child without having to override add() or the other Collection
     * methods that add children to the set.
     * </p>
     *
     * @param targetChild the child to create the Child on behalf of
     * @param peer        the peer if the tragetChild and the peer are related by an implementation of BeanContextProxy
     */

    protected BCSChild createBCSChild(org.omg.CORBA.Object targetChild, 
  				      org.omg.CORBA.Object peer)
	{
		return new BCSChild(targetChild, peer);
    }

	protected BCSChild createBCSChild(org.omg.CORBA.Object targetChild, 
					  org.omg.CORBA.Object peer,String childName)
	{
		return new BCSChild(targetChild, peer,childName );
    }

	/************************************************************************/
    //Should we add give a tag for each object, 
	//just a literal name with String type? So we can search the components inside
	//one context by just the names of nested components.
	//TO DO

    /**
     * <p>
     * Adds/nests a child within this BeanContext
     * </p>
     * <p>
     * Invoked as a side effect of java.beans.Beans.instantiate().
     * </p>
     * 
     * @param targetChildren The child objects to nest within this BeanContext
     */

	public boolean add(org.omg.CORBA.Object targetChild) 
	throws IllegalArgumentException,IllegalStateException,NullPointerException
	{
		return addNamedChild(targetChild, null);
	}

    
    public boolean addNamedChild(org.omg.CORBA.Object targetChild, String objectId) 
	throws IllegalArgumentException,IllegalStateException,NullPointerException
	{
  
	  //System.out.println("addNamedChild :entered");

	    if (targetChild == null) 
		throw new NullPointerException("targetChild Null in add"); 
    

	    // The specification requires that we do nothing if the child
	    // is already nested herein.
	    if (children.contains(targetChild)) {
	        System.out.println("addNamedChild:We have found already");
		return false;
	    }

	    org.omg.CORBA.Object myProxy = getMyProxy();//getBeanContextPeer();

	    if (!validatePendingAdd(targetChild)) {
		throw new IllegalStateException(); 
	    }

	    // The specification requires that we invoke setBeanContext() on the
	    // newly added child if it implements 
	    //the java.beans.beancontext.BeanContextChild interface
	    //System.out.println("BCS:add:1+targetChild"+targetChild);

	    BeanContextChild cbcc  = BeanContextChildHelper.narrow(
					getChildBeanContextChild(targetChild));
	    BeanContextChild  bccp = null;

	    //System.out.println("BCS:add:2:"+cbcc);

	    synchronized(targetChild) {

		//if (targetChild instanceof BeanContextProxy) {
		if (targetChild._is_a(_BeanContextProxyImplBase._ob_ids_[0])) {
		  //System.out.println("add:targetChild is BeanContextProxy");
		    bccp = ((BeanContextProxy)targetChild).getBeanContextProxy();
		    if (bccp == null) 
			throw new NullPointerException("BeanContextPeer.getBeanContextProxy()");
		}

		//BCSChild bcsc  = createBCSChild(targetChild, bccp);
		BCSChild bcsc  = createBCSChild(targetChild, bccp, objectId);
		BCSChild pbcsc = null;

		//System.out.println("BCS:add:2:"+bcsc);

		synchronized (children) {
		    children.put(targetChild, bcsc);
		    //System.out.println("BCS:add:3:");
		    if (bccp != null) {
			pbcsc = createBCSChild(bccp, targetChild, objectId);
			children.put(bccp,pbcsc);
			//children.put(bccp, pbcsc = createBCSChild(bccp, targetChild)); 
			System.out.println("BCS:puttinh:child:"+objectId);
		    }
		}

		//System.out.println("BCS:add:4:");
		if (cbcc != null) synchronized(cbcc) {
		    try {  
		      //System.out.println("BeanContextSupport:setBeanContext:Before");
			cbcc.setBeanContext(myProxy); //getBeanContextPeer());
			//System.out.println("BeanContextSupport:setBeanContext:exited");
		    } catch (PropertyVetoException pve) {
			synchronized (children) {
			    children.remove(targetChild);
			    if (bccp != null) 
				children.remove(bccp);
			}
			throw new IllegalStateException();
		    }
		    //We don't need to register myself as a listener because
		    //the beanContextChild knows me(its context) and it can fire event
		    cbcc.addPropertyChangeListener("propertyChange/beanContext", myProxy); 
		    cbcc.addVetoableChangeListener("vetoablePropertyChangebeanContext", myProxy);
		}

	        
		if (getChildSerializable(targetChild) ) 
		    serializable++;
		childJustAddedHook(targetChild, bcsc);

		if (bccp != null) {
		    if (getChildSerializable(bccp)) 
			serializable++;
		    childJustAddedHook(bccp, pbcsc);
		}

		//System.out.println("add:Before fireChildrenAdded");
		// The specification requires that we fire a notification of the change

		org.omg.CORBA.Object[] list;
		if (bccp == null)
		    list = new org.omg.CORBA.Object[] { targetChild };
		else
		    list = new org.omg.CORBA.Object[] { targetChild, bccp };

		fireChildrenAdded(new BeanContextMembershipEventImpl(getMyProxy(),list));
				  //getBeanContextPeer(),list));

		//System.out.println("add:After fireChildrenAdded");
	    }
	    //}
	    //System.out.println("addNamedChild: returned..");
	    return true;
	}

    /**
     * @param targetChildren The child objects to remove
     */

      public boolean remove(org.omg.CORBA.Object targetChild)
    {
	    try{
		return remove(targetChild, true);
		//disconnect from orb
		//WebFlowContextPeer.dispose(targetChild);
	    }catch(IllegalArgumentException ex1){
		System.out.println("IllegalArgumentException"+ex1);
		return false;
	    }
	    catch(IllegalStateException    ex2){
		System.out.println("IllegalStateException"+ex2);
		return false;
	    }
    }
      
     public boolean remove(String objectID)
    {
	    try{
		return remove(objectID, true);
	    }catch(IllegalArgumentException ex1){
		System.out.println("IllegalArgumentException"+ex1);
		return false;
	    }
	    catch(IllegalStateException    ex2){
		System.out.println("IllegalStateException"+ex2);
		return false;
	    }
    }

    /*
     * internal remove used when removal caused by unexpected setBeanContext or
     * by remove() invocation
     */

    protected boolean remove(org.omg.CORBA.Object targetChild, boolean callChildSetBC)
	throws IllegalArgumentException,IllegalStateException
	{

	    if (targetChild == null) throw new IllegalArgumentException();

	    //synchronized(BeanContext.globalHierarchyLock) {
	    if (!contains(targetChild)) 
		return false;

	    if (!validatePendingRemove(targetChild)) {
	        throw new IllegalStateException();
	    }

            BCSChild bcsc  = (BCSChild)children.get(targetChild);
	    BCSChild pbcsc = null;
	    org.omg.CORBA.Object   peer  = null;

	    // we are required to notify the child that it is no longer nested here if
	    // it implements java.beans.beancontext.BeanContextChild

	    synchronized(targetChild) {
		BeanContextChild cbcc = BeanContextChildHelper.narrow(targetChild); 
		//BeanContextChildHelper.narrow(
		//getChildBeanContextChild(targetChild));
	        if (callChildSetBC) {
		    org.omg.CORBA.Object myProxy = getMyProxy();//getBeanContextPeer();
	            if (cbcc != null) synchronized(cbcc) {
		      //System.out.println("BeanContextSupport:remove: removing");
			cbcc.removePropertyChangeListener("propertyChange/beanContext", myProxy);
	                cbcc.removeVetoableChangeListener("vetoablePropertyChange/beanContext", myProxy);
			try {
	                    cbcc.setBeanContext(null);
	                } catch (PropertyVetoException pve1) {
			    cbcc.addPropertyChangeListener("propertyChange/beanContext",myProxy); 
			    cbcc.addVetoableChangeListener("vetoablePropertyChange/beanContext",
							   myProxy);
			    throw new IllegalStateException();
	                }

		    }
	        }

	        synchronized (children) {
		  //System.out.println("BeanContextSupport: remove child from its children list:"+	       " childID:"+cbcc.getObjectID());

		  //Keep the child informations of context which is WebFlow Server
		
		  children.remove(targetChild);
		
		    if (bcsc.isProxyPeer()) {
		        System.out.println("BeanContextSupport: remove :Is It PROXY..");
			pbcsc = (BCSChild)children.get(peer = bcsc.getProxyPeer());
			children.remove(peer);
		    }
		}

	        if (getChildSerializable(targetChild)) serializable--;

	        childJustRemovedHook(targetChild, bcsc);

		if (peer != null) {
	            if (getChildSerializable(peer)) serializable--;
	            childJustRemovedHook(peer, pbcsc);
		}
	    }

	    org.omg.CORBA.Object[] list;
	    if (peer == null)
		list = new org.omg.CORBA.Object[] { targetChild };
	    else
		list = new org.omg.CORBA.Object[] { targetChild, peer };

	    //TO DO LIST. DO LATER
	    //fireChildrenRemoved(new BeanContextMembershipEventImpl(getBeanContextPeer(),  list)); 
	   
	    return true;
	}

      /*
     * internal remove used when removal caused by unexpected setBeanContext or
     * by remove() invocation
     */

    protected boolean remove(String objectID, boolean callChildSetBC)
	throws IllegalArgumentException,IllegalStateException
	{

	    if (objectID == null) throw new IllegalArgumentException();

	    //synchronized(BeanContext.globalHierarchyLock) {
	    if (!contains(objectID)) 
		return false;

	    if (!validatePendingRemove(objectID)) {
	        throw new IllegalStateException();
	    }

            BCSChild bcsc  = (BCSChild)children.get(objectID);
	    BCSChild pbcsc = null;
	    org.omg.CORBA.Object   peer  = null;

	    // we are required to notify the child that it is no longer nested here if
	    // it implements java.beans.beancontext.BeanContextChild

	    synchronized(objectID) {
	        if (callChildSetBC) {
	            BeanContextChild cbcc = BeanContextChildHelper.narrow(
					  getChildBeanContextChild(objectID));
	            if (cbcc != null) synchronized(cbcc) {
			//We don't need to remove myself as listener for "beanContext"
			//property changes from the child "cbcc" because we didn't add
			//myself as a listener before
	                cbcc.removePropertyChangeListener("propertyChange/beanContext",getMyProxy()); 
			cbcc.removeVetoableChangeListener("vetoablePropertyChange/beanContext", getMyProxy());
			try {
	                    cbcc.setBeanContext(null);
	                } catch (PropertyVetoException pve1) {
			    //We don't need to register myself as a listener because
			    //the beanContextChild knows me(its context) and it can fire
			    //event
	                    cbcc.addPropertyChangeListener("propertyChange/beanContext",getMyProxy()); 
			    cbcc.addVetoableChangeListener("vetoablePropertyChange/beanContext",getMyProxy()); 
			    throw new IllegalStateException();
	                }

		    }
	        }

	        synchronized (children) {
		  //Keep the child informations of context which is WebFlow Server
		  children.remove(objectID);

		    if (bcsc.isProxyPeer()) {
			pbcsc = (BCSChild)children.get(peer = bcsc.getProxyPeer());
			children.remove(peer);
		    }
		}

	        if (getChildSerializable(objectID)) serializable--;

	        childJustRemovedHook(objectID, bcsc);

		if (peer != null) {
	            if (getChildSerializable(peer)) serializable--;
	            childJustRemovedHook(peer, pbcsc);
		}
	    }

	    //TO DO LIST. DO LATER
	    /*org.omg.CORBA.Object[] list;
	    if (peer == null)
		list = new Object[] { objectID };
	    else
		list = new Object[] { objectID, peer };
	    */
	    //fireChildrenRemoved(new BeanContextMembershipEventImpl(getBeanContextPeer(),  list)); 
	   
	    return true;
	}
   

    /**
     * @return if all object objects in specified Collection are children.
     */

    public boolean containsAll(Collection c) {
	synchronized(children) {
	    Iterator i = c.iterator();
	    while (i.hasNext())
	        if(!contains(i.next()))
		    return false;

	    return true;
	}
    }

    /**
     * add Collection to set of Children (Unsupported)
     * implementations must synchronized on the hierarchy lock and "children" protected field
     */

    public boolean addAll(Collection c) {
		/* TO DO */
		//throw new UnsupportedOperationException();
		return false;
    }

    /**
     * remove all specified children (Unsupported)
     * implementations must synchronized on the hierarchy lock and "children" protected field
     */

    public boolean removeAll(Collection c) {
		/* TO DO */
		//throw new UnsupportedOperationException();
		return false;
    }


    /**
     * retain only specified children (Unsupported)
     * implementations must synchronized on the hierarchy lock and "children" protected field
     */

    public boolean retainAll(Collection c) {
	    /* TO DO */
	    //throw new UnsupportedOperationException();
		return false;
    }

    /**
     * clear the children (Unsupported)
     * implementations must synchronized on the hierarchy lock and "children" protected field
     */

    public void clear() {
      children.clear();
		/* TO DO */
	    //throw new UnsupportedOperationException();
    }

    /**
     * Adds a BeanContextMembershipListener
     *
     * @param bcml the BeanContextMembershipListener to add
     * @throw NullPointerException
     */
                                     
    public void addBeanContextMembershipListener(BeanContextMembershipListener bcml)
	 	throws NullPointerException
	{
		if (bcml == null) throw new NullPointerException("listener");
		synchronized(bcmListeners) {
			if (bcmListeners.contains(bcml))
				return;
			else
				bcmListeners.add(bcml);
		}
    }
    

    /**
     * Removes a BeanContextMembershipListener
     *
     * @param bcml the BeanContextMembershipListener to remove
     * @throw NullPointerException
     */

    public void removeBeanContextMembershipListener(BeanContextMembershipListener bcml) 
		throws NullPointerException
	{
		if (bcml == null) throw new NullPointerException("listener");
		synchronized(bcmListeners) {
			if (!bcmListeners.contains(bcml))
				return;
			else
				bcmListeners.remove(bcml);
		}
    }


    /**
     * @param name the name of the resource requested.
     * @param child the child object making the request.
     *
     * @return the requested resource as an InputStream
     * @throw  NullPointerException
     */
    /* TO DO LIST */
     public void getResourceAsStream(String name, BeanContextChild bcc)
	 {;}

    /*public InputStream getResourceAsStream(String name, BeanContextChild bcc) 
	 
	{
	if (name == null) throw new NullPointerException("name");
	if (bcc  == null) throw new NullPointerException("bcc");

	boolean isChild;

	synchronized(children) {
	    isChild = children.containsValue(bcc);
	}

	if (isChild) {
	    ClassLoader cl = bcc.getClass().getClassLoader();

	    return cl != null ? cl.getResourceAsStream(name)
			      : ClassLoader.getSystemResourceAsStream(name);
	} else throw new IllegalArgumentException("Not a valid child");
    }
    */
    /**
     * @param name the name of the resource requested.
     * @param child the child object making the request.
     *
     * @return the requested resource as an InputStream
     */
    /* TO DO LIST*/
    public void  getResource(String name, BeanContextChild bcc) { };
	
	/* 
    public URL getResource(String name, BeanContextChild bcc) {
	if (name == null) throw new NullPointerException("name");
	if (bcc  == null) throw new NullPointerException("bcc");

	boolean isChild;

	synchronized(children) {
	    isChild = children.containsValue(bcc);
	}

	if (isChild) {
	    ClassLoader cl = bcc.getClass().getClassLoader();

	    return cl != null ? cl.getResource(name)
			      : ClassLoader.getSystemResource(name);
	} else throw new IllegalArgumentException("Not a valid child");
    }
    */

    
    /**
     * @return if this BeanContext is currently being serialized
     */

    public boolean isSerializing() { return serializing; }

    /**
     * @return an iterator for all the current BCSChild values 
     */

    protected java.util.Iterator bcsChildren() { 
	   synchronized(children) { 
	     return children.values().iterator(); 
	   } 
	}

    /**
     * called by writeObject after defaultWriteObject() but prior to
     * serialization of currently serializable children.
     *
     * This method may be overridden by subclasses to perform custom
     * serialization of their state prior to this superclass serializing
     * the children.
     *
     * This method should not however be used by subclasses to replace their
     * own implementation (if any) of writeObject().
     */
    /* TO DO LIST */
	/*
    protected void bcsPreSerializationHook(ObjectOutputStream oos) throws IOException {
    }
    */

    /**
     * called by readObject after defaultReadObject() but prior to
     * deserialization of any children.
     *
     * This method may be overridden by subclasses to perform custom
     * deserialization of their state prior to this superclass deserializing
     * the children.
     *
     * This method should not however be used by subclasses to replace their
     * own implementation (if any) of readObject().
     */
	/* TO DO LIST */
	/*
    protected void bcsPreDeserializationHook(ObjectInputStream ois) throws IOException, ClassNotFoundException {
    }
	*/

    /**
     * called by readObject with the newly deserialized child and BCSChild
     */
	
	/* TO DO LIST */	
	/*
    protected void childDeserializedHook(Object child, BCSChild bcsc) {
	synchronized(children) {
	    children.put(child, bcsc);
	}
    }
    */

    /*
     * used by writeObject to serialize a Collection
     */

	/* TO DO LIST */
	/*
    protected final void serialize(ObjectOutputStream oos, Collection coll) throws IOException {
   	int      count   = 0;
	Object[] objects = coll.toArray();
    
	for (int i = 0; i < objects.length; i++) {
	    if (objects[i] instanceof Serializable)
		count++;
	    else
		objects[i] = null;
	}

        oos.writeInt(count); // number of subsequent objects

	for (int i = 0; count > 0; i++) {
	    Object o = objects[i];

	    if (o != null) {
		oos.writeObject(o);
		count--;
	    }
	}
    }
    */

    /**
     * used by readObject to deserialize a collection
     */

    /* TO DO LIST */
	/*
    protected final void deserialize(ObjectInputStream ois, Collection coll) throws IOException, ClassNotFoundException {
	int count = 0;

	count = ois.readInt();

	while (count-- > 0) {
	    coll.add(ois.readObject());
	}
    }
    */
    /** 
     *
     */

    /* TO DO LIST */
	/*
    public final void writeChildren(ObjectOutputStream oos) throws IOException {
	if (serializable <= 0) return;

	boolean prev = serializing;

	serializing = true;

	int count = 0;

	synchronized(children) {
	    Iterator i = children.entrySet().iterator();

	    while (i.hasNext() && count < serializable) {
	        Map.Entry entry = (Map.Entry)i.next();

	        if (entry.getKey() instanceof Serializable) {
	      	    try {
		        oos.writeObject(entry.getKey());   // child
		        oos.writeObject(entry.getValue()); // BCSChild
		    } catch (IOException ioe) {
		        serializing = prev;
		        throw ioe;
		    }
		    count++;
	        }
	    }
	}
	
        serializing = prev;

	if (count != serializable) {
	    throw new IOException("wrote different number of children than expected");
	}

    }
    */

    /**
     * Serialize the BeanContextSupport, if this instance has a distinct 
     * peer (that is this object is acting as a delegate for another) then
     * the children of this instance are not serialized here due to a 
     * 'chicken and egg' problem that occurs on deserialization of the 
     * children at the same time as this instance. 
     *
     * Therefore in situations where there is a distinct peer to this instance
     * it should always call writeObject() followed by writeChildren() and
     * readObject() followed by readChildren().
     *
     * @param oos the ObjectOutputStream
     */

    /* TO DO LIST */
	/*
    private synchronized void writeObject(ObjectOutputStream oos) throws IOException, ClassNotFoundException {
	serializing = true;

	synchronized (BeanContext.globalHierarchyLock) {
	    try {
	        oos.defaultWriteObject(); // serialize the BeanContextSupport object

	        bcsPreSerializationHook(oos);

	        if (serializable > 0 && this.equals(getBeanContextPeer()))
	            writeChildren(oos);

	        serialize(oos, (Collection)bcmListeners);
	    } finally {
	        serializing = false;
	    }
 	}
    }
    */

    /**
     * When an instance of this class is used as a delegate for the
     * implementation of the BeanContext protocols (and its subprotocols)
     * there exists a 'chicken and egg' problem during deserialization 
     */

    /* TO DO LIST */
	/*
    public final void readChildren(ObjectInputStream ois) throws IOException, ClassNotFoundException {
	int count = serializable; 

	while (count-- > 0) {
	    Object                      child = null;
	    BeanContextSupport.BCSChild bscc  = null;
	  
	    try {
	        child = ois.readObject();
	        bscc  = (BeanContextSupport.BCSChild)ois.readObject();
	    } catch (IOException ioe) {
		continue;
	    } catch (ClassNotFoundException cnfe) {
		continue;
	    }


	    synchronized(child) {
		BeanContextChild bcc = null;

		try {
		    bcc = (BeanContextChild)child;
		} catch (ClassCastException cce) {
		    // do nothing;
		}

		if (bcc != null) {
		    try {
			bcc.setBeanContext(getBeanContextPeer());

	               bcc.addPropertyChangeListener("propertyChange/beanContext", childPCL);
	               bcc.addVetoableChangeListener("vetoablePropertyChange/beanContext", childVCL);
	
		    } catch (PropertyVetoException pve) {
			continue;
		    }
		}

		childDeserializedHook(child, bscc);
	    }
	}
    }
    */

    /**
     * deserialize contents ... if this instance has a distinct peer the
     * children are *not* serialized here, the peer's readObject() must call
     * readChildren() after deserializing this instance.
     */

    /* TO DO LIST */
	/*
    private synchronized void readObject(ObjectInputStream ois) throws IOException, ClassNotFoundException {

	synchronized(BeanContext.globalHierarchyLock) {
	    ois.defaultReadObject();

	    initialize();

	    bcsPreDeserializationHook(ois);

	    if (serializable > 0 && this.equals(getBeanContextPeer()))
	        readChildren(ois);

	    deserialize(ois, bcmListeners = new ArrayList(1));
	}
    }
	*/

    /**
     * subclasses may envelope to monitor veto child property changes.
     */
    
	/*
    public void vetoableChange(PropertyChangeEvent pce) throws PropertyVetoException {
	String propertyName = pce.getPropertyName();
	org.omg.CORBA.Object source	    = pce.getSource();

	synchronized(children) {
	    if ("beanContext".equals(propertyName) &&
	        contains(source)	               &&
	        !getBeanContextPeer().equals(pce.getNewValue())
	    ) {
	        if (!validatePendingRemove(source)) {
		    throw new PropertyVetoException("current BeanContext vetoes setBeanContext()", pce);
	        } else ((BCSChild)children.get(source)).setRemovePending(true);
	    }
	}
    }
    */
    
	/**
     * subclasses may envelope to monitor child property changes.
     */

    /*
    public void propertyChange(PropertyChangeEvent pce) 
	throws IllegalArgumentException,IllegalStateException
	{
	String propertyName			 = pce.getPropertyName();
	org.omg.CORBA.Object source	 = pce.getSource();

	synchronized(children) {
	    if ("beanContext".equals(propertyName) &&
	        contains(source)		       &&
	        ((BCSChild)children.get(source)).isRemovePending()) 
		{
	        BeanContext bc = getBeanContextPeer();

	        if (bc.equals(pce.getOldValue()) && !bc.equals(pce.getNewValue())) {
	            remove(source, false);
	        } else {
				((BCSChild)children.get(source)).setRemovePending(false);
	        }
	    }
     }
   }
    */

    /**
     * <p>
     * Subclasses of this class may override, or envelope, this method to
     * add validation behavior for the BeanContext to examine child objects
     * immediately prior to their being added to the BeanContext. 
     * </p>
     *
     * @returns true iff the child may be added to this BeanContext, otherwise false.
     */

    protected boolean validatePendingAdd(Object targetChild) {
	return true;
    }

    /**
     * <p>
     * Subclasses of this class may override, or envelope, this method to
     * add validation behavior for the BeanContext to examine child objects
     * immediately prior to their being removed from the BeanContext. 
     * </p>
     *
     * @returns true iff the child may be removed from this BeanContext, otherwise false.
     */

    protected boolean validatePendingRemove(Object targetChild) {
	return true;
    }

    /**
     * subclasses may override this method to simply extend add() semantics
     * after the child has been added and before the event notification has
     * occurred. The method is called with the child synchronized.
     */

    protected void childJustAddedHook(Object child, BCSChild bcsc) {
    }

    /**
     * subclasses may override this method to simply extend remove() semantics
     * after the child has been removed and before the event notification has
     * occurred. The method is called with the child synchronized.
     */

    protected void childJustRemovedHook(Object child, BCSChild bcsc) {
    }

    protected static final boolean getChildSerializable(Object obj) 
	{
      return true;
    }
    


    /**
     * @return the PropertyChangeListener (if any) of the specified child
     */

    protected static final org.omg.CORBA.Object getChildPropertyChangeListener(Object child) {
	try {
	    return (org.omg.CORBA.Object)child;
	} catch (ClassCastException cce) {
	    return null;
	}
    }

    /**
     * @return the VetoableChangeListener (if any) of the specified child
     */

    protected static final org.omg.CORBA.Object getChildVetoableChangeListener(Object child) {
	try {
	    return (org.omg.CORBA.Object)child;
	} catch (ClassCastException cce) {
	    return null;
	}
    }

    /**
     * @return the BeanContextMembershipListener (if any) of the specified child
     */
    
    protected static final org.omg.CORBA.Object getChildBeanContextMembershipListener(Object child) {
	try {
	    return (org.omg.CORBA.Object)child;
	} catch (ClassCastException cce) {
	    return null;
	}
    }
	

    /**
     * @return the BeanContextChild (if any) of the specified child
     * @throw IllegalArgumentException if child implements both BeanContextChild and BeanContextProxy
     */

    protected  final org.omg.CORBA.Object getChildBeanContextChild(
	   org.omg.CORBA.Object child) throws IllegalArgumentException
	 {
	     return child;
	 }

     protected  final org.omg.CORBA.Object getChildBeanContextChild(String objectID) 
	 throws IllegalArgumentException
	 {
	     BCSChild bcsc  = (BCSChild)children.get(objectID);
	     return bcsc.getChild();
	 }

    /**
     * Fire a BeanContextshipEvent on the BeanContextMembershipListener interface
     */

	/* TO DO LIST */

    protected final void fireChildrenAdded(BeanContextMembershipEventImpl bcme) {
		java.lang.Object[] copy;
		_BeanContextMembershipEventImplBase_tie o_bcme;

		/* We should send CORBA event o_bcme but not bcme
		   o_bcme = new BeanContextMembershipEvent_tie(bcme);
		 **/
		o_bcme = new _BeanContextMembershipEventImplBase_tie(bcme);
		 						  
		synchronized(bcmListeners) { copy = bcmListeners.toArray(); }

		for (int i = 0; i < copy.length; i++){
		  org.omg.CORBA.Object c = (org.omg.CORBA.Object)copy[i];
		  (BeanContextMembershipListenerHelper.narrow(c)).childrenAdded(o_bcme);
		}
	}

    /**
     * Fire a BeanContextshipEvent on the BeanContextMembershipListener interface
     */

    protected final void fireChildrenRemoved(BeanContextMembershipEventImpl bcme) 
	{
		java.lang.Object[] copy;
		_BeanContextMembershipEventImplBase_tie o_bcme;
				
		/* We should send CORBA event o_bcme but not bcme
		   o_bcme = new BeanContextMembershipEvent_tie(bcme);
		 **/
		
		o_bcme = new _BeanContextMembershipEventImplBase_tie(bcme);	  
		synchronized(bcmListeners) { copy = bcmListeners.toArray(); }

		for (int i = 0; i < copy.length; i++){
		  org.omg.CORBA.Object c = (org.omg.CORBA.Object)copy[i];
		 (BeanContextMembershipListenerHelper.narrow(c)).childrenRemoved(o_bcme);
		}
    }

    /**
     * protected method called from constructor and readObject to initialize
     * transient state of BeanContextSupport instance.
     *
     * This class uses this method to instantiate inner class listeners used
     * to monitor PropertyChange and VetoableChange events on children.
     *
     * subclasses may envelope this method to add their own initialization
     * behavior
     */

    protected synchronized void initialize() {
		children     = new myHashMap(serializable + 1);
		bcmListeners = new ArrayList(1);

		//childPCL = new PropertyChangeListenerImpl() ;
		/*{ */

	    /*
	     * this adaptor is used by the BeanContextSupport class to forward
	     * property changes from a child to the BeanContext, avoiding 
	     * accidential serialization of the BeanContext by a badly 
	     * behaved Serializable child.
	     */
         /*
			public void propertyChange(PropertyChangeEvent pce) {
				BeanContextSupport.this.propertyChange(pce);
			}
		};
        */
		//childVCL = new VetoableChangeListenerImpl() ;
		/*{ */

	    /*
	     * this adaptor is used by the BeanContextSupport class to forward
	     * vetoable changes from a child to the BeanContext, avoiding 
	     * accidential serialization of the BeanContext by a badly 
	     * behaved Serializable child.
	     */
          /*
			public void vetoableChange(PropertyChangeEvent pce) throws PropertyVetoException {
				BeanContextSupport.this.vetoableChange(pce);
            }
        };
		*/
    }

    /**
     * @returns a copy of the current nested children
     */
	 /* TO DO LIST */
     /*
    protected final Object[] copyChildren() {
		synchronized(children) 
		{ 
			return children.keySet().toArray(); 
		}
    }
    */
    /**
     * @return if two class objects, or their names are equal.
     */

    protected static final boolean classEquals(Class first, Class second) {
	return first.equals(second) || first.getName().equals(second.getName());
    }


    /*
     * fields
     */


    /**
     * all accesses to the <code> protected HashMap children </code> field
     * shall be synchronized on that object.
     */

    protected transient myHashMap		children;

    private   	        int 		serializable  = 0; // children serializable

    /**
     * all accesses to the <code> protected ArrayList bcmListeners </code> field
     * shall be synchronized on that object.
     */

    protected transient ArrayList	bcmListeners;

    // 
    protected 		Locale		locale;

    protected 		boolean		okToUseGui;

    protected 		boolean		designTime;

    /*
     * transient 
     */

    //private transient PropertyChangeListener childPCL;

    //private transient VetoableChangeListener childVCL;

    private transient boolean		     serializing;

}
