package WebFlow;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;

public class Client 
{
    //
    // Standalone program initialization
    //
    public static void main(String args[])
    {
        configReader config;
      
	try
	{
          
	    // Create ORB 
         Properties props = System.getProperties();
         props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
         props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
            System.setProperties(props);

            ORB orb = ORB.init(args, props);

	    // Connect to the master server
	    

            String masterURL = args[0];
	    String ref;
	    org.omg.CORBA.Object obj=null;
	    boolean flag=true;
	    while(flag){
	      ref = getIORFromURL(masterURL);
              System.out.println(ref);
	      obj = orb.string_to_object(ref);
	      boolean non_exist = true;
	      try{
		non_exist = obj._non_existent();
	      }catch(org.omg.CORBA.COMM_FAILURE ex){}
	       catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}

	      if (!non_exist)
		flag = false;
              try{
		Thread.sleep(500);
	      }catch(InterruptedException ex){
	      }

	    }

	    if(obj == null)
		throw new RuntimeException();

	    WebFlowContext ws = WebFlowContextHelper.narrow(obj);

	    if(ws == null)
			throw new RuntimeException();
	    
	    System.out.println("Client: Connected to the Master Server");


	    // connect to the slave
  

           WebFlowContext slave, subContext;

           slave = WebFlowContextHelper.narrow(ws.getContext("master_test/slave_test"));
           System.out.println("Client: Connected to the Slave Server");
           // create a subContext of the Slave context
           if(slave == null) System.out.println("slave is null!");
           System.out.println("create a subContext");
           org.omg.CORBA.Object sc = slave.addNewContext("subContext");

           // test existence of the subContext
	      boolean failure = true;
	      try{
		failure = sc._non_existent();
	      }catch(org.omg.CORBA.COMM_FAILURE ex){}
	       catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}
           System.out.println("Failure? "+failure);

           subContext = WebFlowContextHelper.narrow(sc);
           System.out.println("Client: SubContext created");

           /* add a module
             p1 = subContext.addNewModule("hello_1");
      	     hello hh  = helloHelper.narrow(p1);
             hh.sayHello();
           */


	   // now exit gracefully
           try {
             ws.removeMyself();
           } catch (Exception e) {;}

	} catch (Exception e1) {System.out.println(e1);}
           System.out.println("TEST COMPLETED");
    }



  
    public static String  getIORFromURL(String url) {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
      try {
        URL u = new URL(url);
        // now turn the URL into a DataInputStream
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
              //System.out.println("configReader:getIORfromURL:line"+thisLine);
		  masterServerIOR += thisLine;
            } // while loop ends here
          }  // end try
          catch (Exception e) {
            System.out.println("configReader:getIORfromURL:"+e);
          }
        } // end try
        catch (Exception e) {
          System.out.println("configReader:getIORfromURL:"+e);
        }

      } // end try
      catch (MalformedURLException e) {
        System.out.println("configReader:getIORfromURL:"+url + " is not a parseable URL");
        System.out.println("configReader:getIORfromURL:"+e);
      }
      
      return masterServerIOR;
      
    }

}





