package WebFlow.ContextManager; 

import WebFlow.*; 
import WebFlow.event.*;
import WebFlow.hashtable.*;
import org.omg.CORBA.*;
import java.io.*;
import java.net.*; 
import java.util.*;

public class Client{


   public static void main(String args[])
   {
      configReader config ; 

      try
      {
         //  Create ORB
         Properties props = System.getProperties();
         props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
         props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
            System.setProperties(props);

            ORB orb = ORB.init(args, props);

         //  Connect to the master server


	    /*
         if(args.length !=1) {
           System.out.println("Usage:");
           System.out.println("   WebFlow.JobService.Client url xml");
           System.exit(1);
	 }    
	 */

         String masterURL = ""; 
	 if(args.length <1) {
            masterURL = "http://osprey4.npac.syr.edu:8001/IOR/CM_master.txt";
         }
         else {
            masterURL = args[0] ; 
         }

         String ref ; 
         org.omg.CORBA.Object obj = null ; 
         System.out.println(" masterURL : "+masterURL); 

         ref = getIORFromURL(masterURL); 

         System.out.println("REF: "+ref); 

         obj = orb.string_to_object(ref); 

         if(obj == null)
              throw new RuntimeException(); 

         WebFlowContext ws =  WebFlowContextHelper.narrow(obj);
         System.out.println("Clinet: got master "+ws);
  
         if(ws == null)
               throw new RuntimeException(); 
         
     WebFlowContext p1=null;
     WebFlowContext p2=null; 

         /* add ContextManager to the master */

      ContextManager cm_m=ContextManagerHelper.narrow
                   (ws.addNewModule("ContextManager"));   
      if(cm_m==null) System.out.println("cm_m is null");      
      ContextData cd_m=ContextDataHelper.narrow
                   (ws.addNewModule("ContextData"));   
      if(cd_m==null) System.out.println("cm_d is null");      

         /* create two project contexts p1.PC and p2.PC */
      try {
            p1 = WebFlowContextHelper.narrow(ws.addNewContext("p1.PC"));
            p2 = WebFlowContextHelper.narrow(ws.addNewContext("p2.PC"));
      }
      catch(Exception e) {System.out.println(e);}

         /* add ContextManager to each of project contexts */

      ContextManager cm_p1=ContextManagerHelper.narrow
                   (p1.addNewModule("ContextManager"));   
      ContextManager cm_p2=ContextManagerHelper.narrow
                   (p2.addNewModule("ContextManager"));   

      try {          
         /* create session contexts in p1 */
 WebFlowContext p1s1 = WebFlowContextHelper.narrow(p1.addNewContext("s1.SC"));
 WebFlowContext p1s2 = WebFlowContextHelper.narrow(p1.addNewContext("s2.SC"));
 WebFlowContext p1s3 = WebFlowContextHelper.narrow(p1.addNewContext("s3.SC"));

         /* create session contexts in p2 */
 WebFlowContext p2s1 = WebFlowContextHelper.narrow(p2.addNewContext("s1.SC"));
 WebFlowContext p2s2 = WebFlowContextHelper.narrow(p2.addNewContext("s2.SC"));
 WebFlowContext p2s3 = WebFlowContextHelper.narrow(p2.addNewContext("s3.SC"));
 WebFlowContext p2s4 = WebFlowContextHelper.narrow(p2.addNewContext("s4.SC"));
 WebFlowContext p2s5 = WebFlowContextHelper.narrow(p2.addNewContext("s5.SC"));
      }
      catch(Exception e) {System.out.println(e);}

        /* test the ContextManager module */ 

    cm_m.test(); 
    System.out.println("how many Project contexts?");
    WebFlowContext[] Projects = cm_m.makeListOfContexts(ws,".PC");
    System.out.println(Projects.length);       

 
    System.out.println("how many Sessions of p1?");
    WebFlowContext[] Sessions1 = cm_p1.makeListOfContexts(p1,".SC");
    System.out.println(Sessions1.length);       

    System.out.println("list names of all p2 sessions");
    WebFlowContext[] Sessions2 = cm_p2.makeListOfContexts(p2,".SC");
    int nn = Sessions2.length;       
    for(int i=0; i<nn; i++) { 
       System.out.println(Sessions2[i].getObjectID());
    }   

       /* clean */
   
    p1.removeMyself();
    p2.removeMyself();
    ws.removeModule(cm_m); 
    
       } catch(COMM_FAILURE ex) {
        System.out.println("Command_Error: "+ex); 

        System.err.println(ex.getMessage()); 
        ex.printStackTrace(); 
        System.exit(1); 
       }  
   } 

   static public String getIORFromURL(String url) {

   System.out.println("Slave WebFlow is getting IOR from url:"+url); 
   String masterServerIOR =""; 
   String thisLine = null ; 

   // Open the URL for reading 
 
   try{
        URL u = new URL(url); 

        // now turn the URL into a DataInputStream

        try{
         DataInputStream theHTML = new DataInputStream(u.openStream());

          while((thisLine = theHTML.readLine()) != null){ 
             masterServerIOR += thisLine ; 
          } 
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
        }
     }
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
     }
    return masterServerIOR ; 
  }
}





