package WebFlow;
 
import org.omg.CORBA.*;
import java.io.*;
import java.util.*;


public class FacServer
{
    public static void main(String args[])
    {
	try
	{
	     Properties props = System.getProperties();
	     props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	     props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
	     System.setProperties(props);

            //
            // Create ORB and BOA
            //
            ORB orb = ORB.init(args, props);
	        BOA boa = ((com.ooc.CORBA.ORB)orb).BOA_init(args, props);

	        //
            // Set the concurrency model
            //
            com.ooc.CORBA.ORB.conc_model(
                com.ooc.CORBA.ORB.ConcModel.ConcModelThreaded);

            if(com.ooc.CORBA.BOA.conc_model() !=
               com.ooc.CORBA.BOA.ConcModel.ConcModelThreadPool)
            {
                com.ooc.CORBA.BOA.conc_model(
                    com.ooc.CORBA.BOA.ConcModel.ConcModelThreadPerRequest);
            }

			String WebFlowIOR = args[0];
		    String ConfigIOR  = args[1];
			int  myColor    = Integer.parseInt(args[2]);   
			//System.out.println("Factory server:wior:"+WebFlowIOR+
			//	" cior:"+ConfigIOR);
			FactoryImpl conn = new FactoryImpl(WebFlowIOR,ConfigIOR, myColor,orb,boa);
	   	    //System.out.println("Factory server: start for accepting request");
          
			//
			// Run implementation
			//
			boa.impl_is_ready(null);
			System.out.println("FACTORY SERVER EXITS NOT...");
			System.exit(0);
	}
	catch(SystemException ex)
	{
	    System.err.println("Here Factory server:"+ex.getMessage());
	    System.exit(1);
	}
    }
}


