package WebFlow;
import java.util.*;

public class HookupTarget {
    public org.omg.CORBA.Object source;
    public String  sourceObjectID, eventID;
    public org.omg.CORBA.Object target;
    String targetObjectID,targetMethod;
    public static final int PULL = 1;
    public static final int PUSH = 2;
    public int flowModel ;
    Vector buffer; //will be used for only PULL models

    HookupTarget(org.omg.CORBA.Object source, String sourceObjectID,String  eventID,
		 org.omg.CORBA.Object target, String targetObjectID, String targetMethod) 
    {
	this.source = source;
	this.sourceObjectID = sourceObjectID;
	this.eventID = eventID;
	this.target = target;
	this.targetObjectID = targetObjectID;
	this.targetMethod   = targetMethod;
    }

    //the model is PUSH model or PULL model?
    public void setFlowModel(int flowModel)
    {
	this.flowModel = flowModel;
	buffer = new Vector();
    }

    public int getFlowModel()
    {
	return flowModel;
    }

    public Vector getEvents()
    {
	Vector list=null;
	synchronized(buffer){
	    list = (Vector)buffer.clone();
	    buffer.clear();
	}
	return list;
    }

    public void putEvent(org.omg.CORBA.Object evt)
    {
	synchronized(buffer){
	    buffer.add(evt);
	}
    }

    public org.omg.CORBA.Object getSource()
    {
	return source;
    }
    public org.omg.CORBA.Object getTarget()
    {
	return target;
    }

    public String getSourceObjectID()
    {
	return sourceObjectID;
    }

     public String getTargetObjectID()
    {
	return targetObjectID;
    }

    public String getEventID()
    {
	return eventID;
    }

    public String getTargetMethod()
    {
	return targetMethod;
    }
           
}
