package WebFlow.event;
import org.omg.CORBA.*;
import java.util.*;

public class PropertyChangeEventImpl extends _PropertyChangeEventImplBase{
   
    /**
     * @param source  The bean that fired the event.
     * @param propertyName  The programmatic name of the property
     *		that was changed.
     * @param oldValue  The old value of the property.
     * @param newValue  The new value of the property.
     */
    public PropertyChangeEventImpl(org.omg.CORBA.Object source, 
			       String propertyName,
			       org.omg.CORBA.Any oldValue, 
			       org.omg.CORBA.Any newValue) 
   {
        source_ = source;
	this.propertyName = propertyName;
	this.newValue = newValue;
	this.oldValue = oldValue;
    }

    public PropertyChangeEventImpl(org.omg.CORBA.Object source, 
			       String propertyName,
			       String oldValue, 
			       String newValue) 
   {
     Properties props = System.getProperties();
     props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
     props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
     System.setProperties(props);
     String []args={};

        org.omg.CORBA.ORB orb_ = org.omg.CORBA.ORB.init(args, props);
        Any any_oldValue = orb_.create_any();
	any_oldValue.insert_string(oldValue);
	Any any_newValue = orb_.create_any();
	any_newValue.insert_string(newValue);

        source_ = source;
	this.propertyName = propertyName;
	this.newValue = any_newValue;
	this.oldValue = any_oldValue;
    }

   public PropertyChangeEventImpl(org.omg.CORBA.Object source, 
			       String propertyName,
			       org.omg.CORBA.Object oldValue, 
			       org.omg.CORBA.Object newValue) 
   {
        Properties props = System.getProperties();
     props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
     props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
     System.setProperties(props);
     String []args={};

        org.omg.CORBA.ORB orb_ = org.omg.CORBA.ORB.init(args, props);
        Any any_oldValue = orb_.create_any();
	any_oldValue.insert_Object(oldValue);
	Any any_newValue = orb_.create_any();
	any_newValue.insert_Object(newValue);

        source_ = source;
	this.propertyName = propertyName;
	this.newValue = any_newValue;
	this.oldValue = any_oldValue;
    }

  
    /**
     * @return  The programmatic name of the property that was changed.
     *		May be null if multiple properties have changed.
     */
    public String getPropertyName() {
	return propertyName;
    }
    
    public  void setPropertyName(String propertyName) {
	this.propertyName = propertyName;
    }
 
    /**
     * @return  The new value for the property, expressed as an Object.
     *		May be null if multiple properties have changed.
     */
    public org.omg.CORBA.Any getNewValue() {
	return newValue;
    }

    /**
     * @return  The old value for the property, expressed as an Object.
     *		May be null if multiple properties have changed.
     */
    public org.omg.CORBA.Any getOldValue() {
	return oldValue;
    }   

    /**
     * @param propagationId  The propagationId object for the event.
     */
    public void setPropagationId(org.omg.CORBA.Object propagationId) {
	this.propagationId = propagationId;
    }

    /**
     * The "propagationId" field is reserved for future use.  In Beans 1.0
     * the sole requirement is that if a listener catches a PropertyChangeEvent
     * and then fires a PropertyChangeEvent of its own, then it should
     * make sure that it propagates the propagationId field from its
     * incoming event to its outgoing event.
     *
     * @return the propagationId object associated with a bound/constrained
     *		property update.
     */
    public org.omg.CORBA.Object getPropagationId() {
	return propagationId;
    }

    public org.omg.CORBA.Object getSource(){
	return source_;
    }

    private org.omg.CORBA.Object source_;
  
    private String propertyName;
    private org.omg.CORBA.Any newValue;
    private org.omg.CORBA.Any oldValue;
    private org.omg.CORBA.Object propagationId;
}

