package WebFlow;
import WebFlow.event.*;

import java.lang.reflect.*;
import java.io.*;
import java.util.*;
import java.util.Hashtable;
import java.util.Vector;
import org.omg.CORBA.*;
import java.net.*;

//Read configuration file which looks like this:
//Module/Event Name -----  IDL fileName ----- Implementation Class
//Read this file and store it into "configTable"

public class configReaderImpl extends _configReaderImplBase
{
    private Hashtable configTable;
    //The table for idl files of all modules and events interface idls
    private Vector idlFiles;
    private org.omg.CORBA.ORB orb_;
    Hashtable WFServers;
    public org.omg.CORBA.Object server_;
    public String localFile, masterURL, ServerName;
    public boolean  non_existent=true ;
    public String parentName;
    public boolean isItMaster;
    public String masterServerIOR;
    public String IRstr;

    public class interfaceAndImpl
    {
	public  String idlFileName_,implClassName_;
	public  String flag_;
    
	public interfaceAndImpl(String flag,String idlFileName,
			   String implClassName)
			
	{
	    flag_          = flag;
	    idlFileName_   = idlFileName;
	    implClassName_ = implClassName;
	}
    } //public class interfaceAndImpl

    public String[] getModuleList()
    {
	Vector vmodules = new Vector();
	for(Enumeration list=configTable.elements();list.hasMoreElements();){
	    interfaceAndImpl val = (interfaceAndImpl)list.nextElement();
	    if (val.flag_.equals("Module"))
		vmodules.addElement(val);
	}
	String[]  modules = new String[vmodules.size()];
	vmodules.copyInto(modules);
	return modules;
	
    }
  
    public configReaderImpl(org.omg.CORBA.Object server, 
			    ORB orb, String fileName)
    {
	String s,flag=null;
	org.omg.CORBA.Object IRobj=null;
   
	//create table to keep available WebFlow Servers
	WFServers  = new Hashtable();
	server_ = server;
	orb_ = orb;
	try{
	    IRobj = orb_.resolve_initial_references("InterfaceRepository");
	}catch(org.omg.CORBA.ORBPackage.InvalidName ex){
	    System.out.println("Error in getting IR IOR in configReader:"+ex);
	}
    
    
        IRstr = orb_.object_to_string(IRobj);
    
	configTable = new Hashtable();
	idlFiles    = new Vector();

	
        /*
	File file = new File(fileName);
	try{
	    FileReader     fr = new FileReader(file);
	    BufferedReader br = new BufferedReader(fr);
        */

	//test
	try{
	  BufferedReader br=null;
	  try{
	    URL url = new URL(fileName);
	    InputStreamReader isr = new InputStreamReader(url.openStream());
	    br = new BufferedReader(isr);
          }catch(MalformedURLException e){
	    File file = new File(fileName);
	    FileReader     fr = new FileReader(file);
	    br = new BufferedReader(fr);
	  }
        //test



	    while((s = br.readLine()) != null){
		//skip explanation/comment lines
		if (s.startsWith("Modules:==")){
		    flag = "Module";
		    continue;
		}
		if (s.startsWith("Events:=="))
		    {
			flag = "Event";
			continue;
		    }
	
		StringTokenizer st = new StringTokenizer(s," \r\n\t");
		try{
		    String moduleName        = st.nextToken();
		    if (moduleName.indexOf("=") >=0 ){
			if (!setFileURLName(moduleName))
			  return ;
			continue;
		    }
		    String idlFileName   = st.nextToken();
		    String implClassName = st.nextToken();
		    System.out.println("CONFIG="+moduleName+"="+idlFileName+"="
			     +implClassName+" flag:"+flag );
	  	  	  
		    interfaceAndImpl iai = new interfaceAndImpl(flag,
					idlFileName,implClassName);
		    configTable.put(moduleName,iai);
	 
		    String webflow_define = " -D_WEBFLOW_ ";
		    //Feed idl interface of this module
		    if ((idlFiles.indexOf(idlFileName) < 0)&&
			(!flag.equalsIgnoreCase("Event"))){
			String command = "irfeed -ORBrepository "+
			    IRstr+webflow_define+idlFileName;
			
			try{
			    System.out.println("configReader :irfeeding the file:"+idlFileName+" with:"+command);
			    Process p = Runtime.getRuntime().exec(command);
                            p.waitFor();
			}catch (Exception ex){
			    System.out.println("Error in feeding IDL file :"+
					       idlFileName+ " : "+ex);
			}
			idlFiles.addElement(idlFileName);
		    }
	  
	  
		}catch(NoSuchElementException ex){
		    System.out.println("Reading error the file:"+ex);
		}
	    }
	    //fr.close();
	}catch(IOException e){
	    System.out.println("IOExc. during reading file:"+e);
	}
	System.out.println("Read configuration file..");
	
    }

public String getWFSName ()
{
	return ServerName;
}

public void startDebug(Process p)
  {
    printProcessOut ppo = new printProcessOut(p);
    ppo.startProcess();
  }

public boolean isTheServerRunnning()
  {
     //check first is there any WebFlow server running around
    
    org.omg.CORBA.Object wfProcess = readIOR(orb_, localFile);
    boolean res_non_existent = true;
    if (wfProcess == null)
      return non_existent;

    try{
      //res_non_existent = wfProcess._non_existent();
      res_non_existent = WebFlow.ProxyImpl.nonExistent(wfProcess);
    }catch(org.omg.CORBA.OBJECT_NOT_EXIST exx){}
    catch(org.omg.CORBA.COMM_FAILURE ex){}
    catch(org.omg.CORBA.INV_OBJREF exxx){}
    non_existent = res_non_existent;
    return non_existent;
    
  }


public boolean writeGatewayIOR(org.omg.CORBA.Object masterGateway)
  {
    //If I am master, don't do anything
    if (localFile.equals("none"))
      return false;
  
    //check first is there any WebFlow server running around
    org.omg.CORBA.Object wfProcess = readIOR(orb_, localFile);
    boolean non_exist = true;

    try{
      //non_exist = wfProcess._non_existent();
      non_exist = WebFlow.ProxyImpl.nonExistent(wfProcess);
    }catch(org.omg.CORBA.OBJECT_NOT_EXIST exx){}
    catch(org.omg.CORBA.COMM_FAILURE ex){}
    catch(java.lang.NullPointerException ex){}

    //there is no gateway server running around...
    if (non_exist){
      writeIORtoFile(localFile, masterGateway);
      return non_exist;
    }
    else{
      System.out.println("We have already one GateWay Server running around ...");
      return non_exist;
    }
  }


public void writeIORtoFile(String refFile, org.omg.CORBA.Object gwserver)
{
	try
	{
		String ref = orb_.object_to_string(gwserver);
 		FileOutputStream file = new FileOutputStream(refFile);
		PrintWriter out = new PrintWriter(file);
		out.println(ref);
		out.flush();
		file.close();
	 }
	 catch(IOException ex)
	 {
		System.err.println("Can't write to `" +  ex.getMessage() + "'");
		System.exit(1);
	 }
}

public  static org.omg.CORBA.Object readIOR(org.omg.CORBA.ORB orb ,String fn)
{
    String ref = null;
    try
      {
		String refFile = fn;//"Hello.ref";
		FileInputStream file = new FileInputStream(refFile);
		BufferedReader in =
		new BufferedReader(new InputStreamReader(file));
		ref = in.readLine();
		file.close();
      }
    catch(IOException ex)
      {
            System.err.println("Can't read from `" +
                                   ex.getMessage() + "'");
	    return null;

	    //	System.exit(1);
      }
 
    org.omg.CORBA.Object obj = null;
    try{
	obj = orb.string_to_object(ref);
    }catch(org.omg.CORBA.INV_OBJREF exxx){}
    return obj;
        
  }


public void getIORFromURL(String url)
{
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
      try {
        URL u = new URL(url);
        // now turn the URL into a DataInputStream
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
              System.out.println("configReader:getIORfromURL:line"+thisLine);
		  masterServerIOR += thisLine;
            } // while loop ends here
          }  // end try
          catch (Exception e) {
            System.out.println("configReader:getIORfromURL:"+e);
          }
        } // end try
        catch (Exception e) {
          System.out.println("configReader:getIORfromURL:"+e);
        }

      } // end try
      catch (MalformedURLException e) {
        System.out.println("configReader:getIORfromURL:"+url + " is not a parseable URL");
        System.out.println("configReader:getIORfromURL:"+e);
      }
   
      /*
	//register myselt to master as a slave
	System.out.println("Slave WebFlow :register himself as slave to"+masterServerIOR);
	WebFlowContext master = WebFlowContextHelper.narrow(orb_.string_to_object(masterServerIOR));
	//master =  WebFlowContextHelper.narrow(master.getNamedContext(parentName));
   
	System.out.println("Slave WebFlow :after read master IOR:"+master);
	String objectID = parentName+"/"+ServerName;
	ServerName = objectID;
	master.insertRemoteServer(ServerName,objectID,server_);
	//master.addWFServer(ServerName, server_);
	System.out.println("Slave WebFlow :sent addWFServer request");
	*/
}


public boolean  setFileURLName(String pair)
{
	int k = pair.indexOf("=");
	String attr = pair.substring(0, k);
      String val  = pair.substring(k+1);
	System.out.println("configReader : got attr: "+attr+" val :"+val+"/");

	if (attr.equals("File")){
         localFile = val;
	 if (!val.equals("none")){
	   isItMaster = true;
	   return isTheServerRunnning();
	   //writeIORtoFile(val, server_);
	 }
  	}
	else if (attr.equals("URL")){
	    masterURL = val;			
	    //if (localFile.equals("none"))
	    //getIORFromURL(val);		
	}
	else if (attr.equals("ServerName")){
	    ServerName = val;
	}
	else if (attr.equals("PARENT")){
	    parentName = val;
	    if (localFile.equals("none") && (!parentName.equals("none") )){
	      isItMaster = false;
	      getIORFromURL(masterURL);
	      
	    }
	}
	else if (attr.equals("WEBFLOW_IDL")){
	  String bc_idl = val+File.separator+"BC.idl";
	  //Feed BC.idl into IR
	  //assume that BC.idl stays in the directory WEBFLOW_IDL 
	  String command = "irfeed -ORBrepository "+IRstr+" "+bc_idl;
	  System.out.println("I am feeding BC.idl with:"+command);
	  try{
	    Process p = Runtime.getRuntime().exec(command);	
	    p.waitFor();
	  }catch (Exception ex){
	    System.out.println("Error in feeding BC.idl file :"+
			       bc_idl+ " : "+ex);
	  }
	  //////
	}

	return true;
}

public boolean isMaster()
{
  return isItMaster;
}

public Hashtable getConfig()
  {
    return configTable;
        
  }

public String getImplClass(String mouduleOrEventName)
  {
    interfaceAndImpl impl ;
    impl = (interfaceAndImpl)configTable.get(mouduleOrEventName);
    return (impl.implClassName_);
       
  }
  
public String getIdlFileName(String mouduleOrEventName)
  {
    interfaceAndImpl impl ;
    impl = (interfaceAndImpl)configTable.get(mouduleOrEventName);
    return ((impl == null)?null:impl.idlFileName_);
  }

    public void addWFServer(String name, org.omg.CORBA.Object server)
	{
		WFServers.put(name, server);
	}
    
    public void removeWFServer(String name)
	{
		WFServers.remove(name);
	}

	public  String[] getAllWFServers()
	{
		int k;
		Enumeration e;
		Enumeration keys = WFServers.keys();
		String []servers = new String[WFServers.size()];
		for (k=0 ; keys.hasMoreElements();k++) 
		    servers[k]= (String)keys.nextElement();
		return servers;
	}

	public org.omg.CORBA.Object getWFServer(String name)
	{
		org.omg.CORBA.Object ref = (org.omg.CORBA.Object)WFServers.get(name);
		return ref;
	}			
}
