package WebFlow.dbServer;

import WebFlow.*;
import WebFlow.event.*;
//import WebFlow.jdbc.*;
import WebFlow.hashtable.*;
import java.awt.*;
import java.io.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.net.*;
import java.util.*;
import org.omg.CORBA.*;

public class dbServer_Client extends Frame {
  public ControlPanel controlPanel;//buttons
  public Panel headerPanel;
  public DisplayPanel dp;//display area
  private ORB orb;
  private org.omg.CORBA.Object obj;
  private static org.omg.CORBA.Object p1, p2, p3;
  private static ContextData hashtable;
  private static dbServer db;

   public static void main(String args[])
   {
      configReader config ;

      try
      {
         //  Create ORB
         Properties props = System.getProperties();
         props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
         props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
            System.setProperties(props);

            ORB orb = ORB.init(args, props);


         //  Connect to the master server

         if(args.length !=1) {
           System.out.println("Usage:");
           System.out.println("   WebFlow.JobService.Client url xml");
           System.out.println("     url - url to the master's IOR");
           System.exit(1);
         }

         String masterURL = args[0] ;

         String ref ;
         org.omg.CORBA.Object obj = null ;
         System.out.println(" masterURL : "+masterURL);

         ref = getIORFromURL(masterURL);
         System.out.println("REF: "+ref);

         obj = orb.string_to_object(ref);

         if(obj == null)
              throw new RuntimeException();
         WebFlowContext ws =  WebFlowContextHelper.narrow(obj);
         System.out.println("DbServer_Client: got master "+ws);

         if(ws == null)
               throw new RuntimeException();

         System.out.println("attach jdbc");
         p1 = ws.addNewModule("Jdbc");
/*
         System.out.println("narrow jdbc");
		oracleImpl = JdbcHelper.narrow( p1 );
*/

         System.out.println("attach hashtable" );
		 p2 = ws.addNewModule( "ContextData" );
         System.out.println("narrow hashtable" );
		hashtable = ContextDataHelper.narrow(p2);

         System.out.println("attach dbServer" );
		 p3 = ws.addNewModule( "dbServer" );
		System.out.println("narrow dbServer" );
		db = dbServerHelper.narrow( p3 );

		new dbServer_Client();
		}
     catch(COMM_FAILURE ex) {
        System.out.println("Command_Error: "+ex);

        System.err.println(ex.getMessage());
        ex.printStackTrace();
        System.exit(1);
       }
  }//method

   static public String getIORFromURL(String url) {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR ="";
	String thisLine = null ;

   // Open the URL for reading

   try{
        URL u = new URL(url);

        // now turn the URL into a DataInputStream

        try{
         DataInputStream theHTML = new DataInputStream(u.openStream());

          while((thisLine = theHTML.readLine()) != null){
             masterServerIOR += thisLine ;
          }
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e);
        }
     }
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e);
     }
    return masterServerIOR ;
  }


 /**Input:void
    Output:void
    Function:Initilize the screen.
 **/
  public dbServer_Client() {
    super( "JDBC CORBA" );
    setSize( 600, 450 );
    // set background color to lightGray, add HeaderPanel,
    //DisplayPanel and controlPanel components
    setBackground(Color.pink);
    headerPanel = new Panel();
    headerPanel.setFont(new Font("Helvetica", Font.PLAIN, 24));
    headerPanel.add(new Label("CORBA Database Connectivity"));
    add("North", headerPanel);
    add("Center", dp = new DisplayPanel());//display area
    //buttons!
    add("South",  controlPanel = new ControlPanel(this));
    setVisible( true );
    show();

  }

  public void adddate( String name, String project, String application, String param, String value ){
	System.out.println( "Adddate()..." );
    if( name.equals( null ) || application.equals( "" ) || project.equals( "" ) )
        dp.showerr();
    else{
		if( param.equals( null ) )
			param = "null";
		if( value.equals( null ) )
			value = "null";
		hashtable.test();
		hashtable.setParam( "user_name", name );	
		hashtable.setParam( "project", project);	
		hashtable.setParam( "application", application );	
		hashtable.setParam( "parameter", param );	
		hashtable.setParam( "value", value );	
		System.out.println( hashtable.getParam( "user_name" ) + hashtable.getParam( "project" ) );
		hashtable.test();
		db.myJdbc( p1 );
		db.store( p2 );
        dp.show( name + "\n" + project + "\n" + application + "\n" + param + "\n" + value  );
    }
  }

/*   public void delete_date( String name, String project, String application String param, String value ) {
    if( name.equals( null ) || project.equals( null ) || application.equals( null ))
        dp.showerr();
    else {
		try{
	        oracleImpl.deleteRecord( name, project, application );
			dp.showOk( 2 );
		}
		catch ( WebFlow.jdbc.JdbcPackage.CanNotFindRecord cnfd ){
			System.out.println( cnfd.user_name + cnfd.project );
		}
    }
   }
*/
  public void destory() {
    System.exit( 1 );
  }
}

class ControlPanel extends Panel implements ActionListener {

  private dbServer_Client parent;
  private TextField name, project, application, param, value;
  private Label lbl;
  private Panel searchPanel;
  private Panel connectionPanel;
  private Button closeButton, clearButton, insert, reinsert;

  /**Input:Client obj.
     Output:void
     Function:initialize the screen.
  **/
  public ControlPanel( dbServer_Client clt) {

    parent = clt;
    setLayout(new BorderLayout());
    setFont(new Font("Helvitica", Font.PLAIN, 14));
    searchPanel = new Panel();
    searchPanel.setLayout( new GridLayout( 5, 2 ) );
    connectionPanel = new Panel();

    reinsert = new Button( "Restore Process" );
    closeButton = new Button("Close");
    insert = new Button("Add Process");
    clearButton = new Button("Clear");
    insert.addActionListener(this);
    reinsert.addActionListener( this );
    closeButton.addActionListener(this);
    clearButton.addActionListener(this);

    connectionPanel.add( insert );
    connectionPanel.add( reinsert );
    connectionPanel.add( closeButton );
    connectionPanel.add( clearButton );

    searchPanel.add( new Label("User Name"));
    searchPanel.add( name = new TextField(20));
    searchPanel.add( new Label("Project"));
    searchPanel.add( project = new TextField(20));
    searchPanel.add( new Label("Process Application"));
    searchPanel.add( application = new TextField( 20 ) );
    searchPanel.add( new Label( "Parameter" ));
    searchPanel.add( param = new TextField( 20 ) );
    searchPanel.add( new Label( "Value" ));
    searchPanel.add( value = new TextField( 20 ) );

    add("North",connectionPanel);
    add("South",searchPanel);
  }

  /**Input:ActionEvent obj.
     Output:void
     Function:waiting something happen.
  **/
  public void actionPerformed(ActionEvent event) {
    String buttonLabel = event.getActionCommand();

   if(buttonLabel.equals("Restore Process")) {
 //     try {
        System.out.println("restore Process " + name.getText() );
/*        parent.delete_date( name.getText(), project.getText(), application.getText(), param.getText(), value.getText() );
      }
    catch (Exception ex) {
      }
*/
    }//if delete 

    if(buttonLabel.equals("Add Process")) {
      try {
       System.out.println("Add Process" + name.getText() );
       parent.adddate( name.getText(), project.getText(), application.getText(), param.getText(), value.getText() );
      }
	 catch (Exception ex) {
      }
    }//if add


	if(buttonLabel.equals("Clear")) {
		name.setText("");
        application.setText("");
        project.setText("");
        param.setText("");
        value.setText("");
    }

  //close connection with database.
    if(buttonLabel.equals("Close")) {
        parent.destory();
        }

  }//method
}//class

/** the DisplayPanel contains a textarea to display the results of our
search
  API:
   DisplayPanel();
   showerr();
 */
class DisplayPanel extends Panel {
  TextArea resultArea;
  String namedata = "Sorry! You should type in User Name, Application, and project.";

  /**Input:void.
     Output:void,
     Function:initialize the display area.
  **/
  public DisplayPanel() {
    setLayout(new BorderLayout(10,10));
    resultArea = new TextArea(15,60);
    resultArea.setBackground(Color.white);
    add("Center",resultArea);
  }

  public void showOk( int a ) {
    resultArea.setFont( new Font("Times-Roman",Font.PLAIN,16));
    setForeground(Color.black);
    if( a == 1 ) 
		resultArea.setText( "Inserting is successful." );
    else
        resultArea.setText( "Deleting is successful." );
  }//method

  public void showerr() {
    resultArea.setFont( new Font("Times-Roman",Font.PLAIN,18));
    setForeground(Color.red);
    resultArea.setText("\n\n\n " + namedata );
    }

  public void show( String temp ){
	resultArea.setFont( new Font("Times-Roman",Font.PLAIN,16));
    setForeground(Color.black);
	resultArea.setText( temp );
  }//method

}//class

