package WebFlow.demo; 
import WebFlow.*; 
import java.util.*; 
import WebFlow.event.*; 

import java.io.*;
import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*; 

public class ActionImpl extends BeanContextChildSupport
                      implements WebFlow.demo.ActionOperations
{
   String msg_ ; 
   org.omg.CORBA.Object peer ;

   public static int numClicks = 0 ; // number of button clicks
   public static String message = "Number of Button Clicks:"+numClicks; 
   public static JButton fire =  new JButton("Fire Button");
   public static JButton quit = new JButton("Quit Button");
   public static JButton reset = new JButton("Reset Button");
   public static final JLabel label1 = new JLabel(message);

   public static  final JFrame frame1 = new JFrame("Action Performed");

   public Component createComponents(){ 

      label1.setLabelFor(fire); 

      JPanel pane1 = new JPanel(); 
      pane1.setBorder(BorderFactory.createEmptyBorder(30,30,30,30)); 
      pane1.setLayout(new GridLayout(0,1)); 

      pane1.add(fire); 
      pane1.add(label1); 
      pane1.add(reset); 
      pane1.add(quit); 

      fire.setBackground(Color.cyan); 
      reset.setBackground(Color.cyan); 
      quit.setBackground(Color.cyan); 

      fire.setForeground(Color.red); 
      reset.setForeground(Color.blue); 
      quit.setForeground(Color.black); 

      //add action listeners to be registered

      fire.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
           runfire();
           System.out.println("Fire button clicked");
           
        }
      });

      reset.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
           runreset();
           System.out.println("Reset button clicked");
           
        }
      });

      quit.addActionListener(new ActionListener(){
         public void actionPerformed(ActionEvent e) {
           runquit();
           System.out.println("Quit button clicked");

        }
      });

      return pane1 ; 
   }

   public ActionImpl(org.omg.CORBA.Object peer , String msg)
              throws WebFlow.NullPointerException
   {
     super(peer); 
     this.peer = peer ; 
     msg_ = msg ; 

     // final JFrame frame1 = new JFrame("Action Performed"); 

     frame1.getContentPane().add(createComponents() , BorderLayout.CENTER); 

    // Finish setting up the frame , and show it

     frame1.setLocation(100,200);
     frame1.pack() ; 
     frame1.setVisible(true); 

   }

   public void runfire()
   {
      System.out.println("Frame1 in run: fire"); 

      numClicks++ ; 
      message = "Number of Button Clicks:" +numClicks; 
      label1.setText(message); 

      actionEvent aevt = new actionEventImpl(getBeanContextChildPeer(),
					     "Fire");
       fireEvent( "Fire_Button" , aevt); 
    }

    public void runreset()
    {
       numClicks = 0 ; 
       message = "Number of Button Clicks:" + numClicks ;  
       label1.setText(message) ; 
          
       actionEvent aevt = new actionEventImpl(getBeanContextChildPeer(),
					      "Reset");
       fireEvent("Reset_Button" , aevt); 
    }

   public void runquit()
   {
      actionEvent aevt = new
           actionEventImpl(getBeanContextChildPeer(),"Quit"); 
      fireEvent("Quit_Button" , aevt); 

      BeanContextChild  prev_bcc,last_bcc;
      last_bcc = BeanContextChildHelper.narrow(getBeanContext());
      prev_bcc = last_bcc;

      while(last_bcc !=null){
    	prev_bcc = last_bcc;
    	last_bcc = BeanContextChildHelper.narrow(last_bcc.getBeanContext());
      }
      WebFlowContext wfc = WebFlowContextHelper.narrow(prev_bcc);
      wfc.removeMyself(); 
   }

    public void sayOK(String msg)
    {
      System.out.println("OK :"+msg+" from ActionImpl"); 
    }

}
