package WebFlow.FileBrowser;

import WebFlow.FileBrowser.FileBrowserUtil.*;
import java.util.*;
import javax.swing.*;
import javax.swing.tree.DefaultMutableTreeNode;
import java.awt.GridLayout;
import java.awt.event.WindowListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Enumeration;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;
import org.omg.CORBA.*;

public class FileBrowserCtr extends JPanel {
    public FileBrowser fileBrowser;


    int sbh=2;
    private String CurrentFile,CurrentFileName,CurrentDirectory;

    
    public FileBrowserCtr (String directory, FileBrowser file_browser) {
	super();

	fileBrowser = file_browser;

	FBFileTreeModel  root = new FBFileTreeModel(directory, this);
	refreshFileBrowser(root, directory);
	System.out.println("FileBrowserCtr is constructed");
    }

    public void refreshFileBrowser(FBFileTreeModel  root,String rootName)
    {
	//remove all the components inside the Panel
	removeAll();
	GridBagLayout gridbag = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	setLayout(gridbag);
	
	FBselectedFile file_field = new FBselectedFile("", 15, "file", this);
	FBDirTree tree = new FBDirTree(root); //!!!,this);
	JScrollPane scrollPane = new JScrollPane(tree);
	tree.addMouseListener(file_field);
	tree.addTreeExpansionListener(root);
	root.addTreeModelListener(tree);
	
	JLabel label = new JLabel("Enter Path and Folder Name :");
	//Row 0
	
	addComponent(this,label,0,0,GridBagConstraints.REMAINDER,1,
		     GridBagConstraints.HORIZONTAL,GridBagConstraints.CENTER,0);

	final FBselectedFile directory_field=new FBselectedFile(rootName,15,
								"directory",this);
	tree.addMouseListener(directory_field);
	directory_field.addActionListener(root);
	
	// Row 1
	addComponent(this,directory_field,0,1,GridBagConstraints.REMAINDER,1,
		     GridBagConstraints.HORIZONTAL,GridBagConstraints.CENTER,0);
	// Row 2 
	scrollPane.setSize(150,300);
	addComponent(this,scrollPane,0,2,GridBagConstraints.REMAINDER,
		     sbh, GridBagConstraints.BOTH,
		     GridBagConstraints.CENTER,1);
	// Row 3
	label = new JLabel("Enter File Name :");
	
	addComponent(this,label,0,sbh+2,GridBagConstraints.REMAINDER,1,
		     GridBagConstraints.HORIZONTAL,GridBagConstraints.CENTER,0);
	
	// Row 4	
	addComponent(this,file_field,0,sbh+3,GridBagConstraints.REMAINDER,1,
		     GridBagConstraints.HORIZONTAL,GridBagConstraints.CENTER,0);
	
	//Erol modifications
	directory_field.addActionListener(file_field);
	tree.addTreeExpansionListener(directory_field);
	tree.addTreeExpansionListener(file_field);
	//Erol
	
	// Row 5
	JButton button1 = new JButton("OK");
	button1.addActionListener(file_field);	
	addComponent(this,button1,0,sbh+4,1,1,
		     GridBagConstraints.HORIZONTAL,GridBagConstraints.WEST,0);
    }
    
    
    protected void addComponent(java.awt.Container container, Component component,
			     int gridx, int gridy, int gridwidth, int gridheight, int fill,
			     int anchor, int weight) {
	
	LayoutManager lm =container.getLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	gbc.gridx = gridx;
	gbc.gridy = gridy;
	gbc.gridwidth = gridwidth;
	gbc.gridheight = gridheight;
	gbc.fill = fill;
	gbc.anchor = anchor;
	if(weight>0) {
	    gbc.weightx=1.0; 
	    gbc.weighty=1.0;
	} 
	container.add(component,gbc);
    }
    
    public static String  getIORFromURL(String url) {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR="";
	String thisLine=null;
	try {
	    URL u = new URL(url);
	    DataInputStream theHTML = new DataInputStream(u.openStream());
	    while ((thisLine = theHTML.readLine()) != null)
		masterServerIOR += thisLine;
	}
	catch (MalformedURLException e) {
	    System.out.println("FileBrowserCtr" + url + " is not a parseable URL");
	    System.out.println("FileBrowserCtr" + e);
	}
	catch (Exception e) {
	    System.out.println("FileBrowserCtr" + e);
	}
	return masterServerIOR;
    }
    
    public String getCurrentFile(){
	return CurrentFile;
    }
    
    public void setCurrentFile(String x){
        CurrentFile = x;
        int i = x.lastIndexOf(File.separator);
        CurrentFileName = x.substring(i + 1);
        CurrentDirectory = x.substring(0, i);
        System.out.println("file name: "+CurrentFileName); 
        System.out.println("dir name : "+CurrentDirectory); 
        System.out.println("file     : "+CurrentFile); 
    }    
}

