package WebFlow.FileBrowser.FileBrowserUtil;

import WebFlow.FileBrowser.*;
import WebFlow.*;
import java.util.*;
import WebFlow.event.*;

import javax.swing.JTextArea;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.JScrollPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.GridLayout;
import java.awt.event.WindowListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Enumeration;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;

import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.event.*;
import javax.swing.tree.*;


public class FBFileTreeModel extends DefaultTreeModel implements  TreeExpansionListener, ActionListener {

    private static FileBrowserCtr viewer;
    private DefaultMutableTreeNode root;
    private static String InitialRootDir;

    public FBFileTreeModel(String dirFullPath, FileBrowserCtr viewer_)
    {
	super(constructTree(InitialRootDir = dirFullPath));
	viewer = viewer_;
	root   = (DefaultMutableTreeNode)(getRoot());
    }
    
    public void actionPerformed(ActionEvent e) {
	String dirname = e.getActionCommand();
	System.out.println("ActionListener: directory name: "+dirname);
	root.removeAllChildren();
	updateTree(dirname,root,dirname);
	System.out.println("After updateTree");
	reload();
	System.out.println("ActionListener:inside FBFileTreeModel");
    }

    private static DefaultMutableTreeNode constructTree(String dirFullPath) {
	String s;
	DefaultMutableTreeNode top=null,one=null;
	
	System.out.println("start constructTree: " + dirFullPath);
	System.out.println("Filter :" + InitialRootDir);
	if (dirFullPath.equals(InitialRootDir)){
	    TreeNodeInfo firstNodeInfo = new TreeNodeInfo(".");
	    firstNodeInfo.setDir();
	    top = new DefaultMutableTreeNode(firstNodeInfo);
	    return top;
	    
	}

	return top;
	/*
	String []flist = viewer.fileBrowser.refreshDirectory(dirFullPath);
	String pwd = flist[0];
	
	TreeNodeInfo firstNodeInfo = new TreeNodeInfo(pwd);

	firstNodeInfo.setDir();
	top = new DefaultMutableTreeNode(firstNodeInfo);

	System.out.println("rootDir "+pwd);

        
        int nfiles = flist.length;
	for(int i=2;i<nfiles;i++) {
	    s = flist[i];
	    System.out.println("file "+s);
	    TreeNodeInfo tn = new TreeNodeInfo(s);
            if (!((tn.filename.equals("."))||(tn.filename.equals("..")))) {
		System.out.println("adding to TREE");
		top.add(one = new DefaultMutableTreeNode(tn));
		//if this is directory, add dummy content file inside
		if (tn.isDir){
		    TreeNodeInfo tn_new = new TreeNodeInfo(".");
		    tn_new.setDummyFileName();	
		    one.add(new DefaultMutableTreeNode(tn_new));
		}
	    }
	}
	return top;
	*/
    }

  //Is directory containing only dummy file 

public boolean isDirDummy( DefaultMutableTreeNode lastComponent)

  {

     java.lang.Object o = lastComponent.getUserObject();

     TreeNodeInfo parentInfo = (TreeNodeInfo)o;



     TreeNode removedOne = lastComponent.getChildAt(0); 

     o = ((DefaultMutableTreeNode)removedOne).getUserObject();

     TreeNodeInfo childInfo = (TreeNodeInfo)o;

     if ((parentInfo.isDir)&&

         (lastComponent.getChildCount() == 1)&&

	 (childInfo.isDummyFileName())){

       System.out.println("it is Dummy Node");

       return true;

     }

     

     else{

       System.out.println("it is NOT Dummy Node");

       return false;

     }

   
  }

    public static int  updateTree(String dirFullPath,DefaultMutableTreeNode top,
				  String lastNodeName)
    {
        String s;
        DefaultMutableTreeNode one = null;
        int childCnt = 0;
	
        System.out.println("Filter :updateTree:"+dirFullPath);
	
        /*
	  backend is expected to send an array of strings with current dir
	  as the first element, a dummy second element, and the actual
	  list of files as the remaining elements
	*/
	String []flist = viewer.fileBrowser.refreshDirectory(dirFullPath);
	
        String pwd = flist[0];
	
	TreeNodeInfo firstNodeInfo = new TreeNodeInfo(lastNodeName);
	firstNodeInfo.setDir();
	top.setUserObject(firstNodeInfo);
	System.out.println("rootDir "+pwd);
	
	int nfiles = flist.length;
	for(int i = 2; i < nfiles; i++) {
	    System.out.println("file "+flist[i]);
	    TreeNodeInfo tn = new TreeNodeInfo(flist[i]);
            if (!(tn.filename.equals(".") || tn.filename.equals(".."))) {
		System.out.println("adding to TREE");
		childCnt++;
		top.add(one = new DefaultMutableTreeNode(tn));
		//if this is directory, add dummy content file inside
		if (tn.isDir) {
		    TreeNodeInfo tn_new = new TreeNodeInfo(".");
		    tn_new.setDummyFileName();
		    one.add(new DefaultMutableTreeNode(tn_new));
		}
	    }
	}
	
	if (childCnt == 0) { // swing does not like empty directories, so add a dummy file
	    TreeNodeInfo tn_new = new TreeNodeInfo(".");
	    tn_new.setDummyFileName();
	    top.add(new DefaultMutableTreeNode(tn_new));
	    childCnt++;
	}

	return childCnt;
    }

public void getSelectedDirContent(TreePath selPath)

  {

    DefaultMutableTreeNode lastComponent = (DefaultMutableTreeNode)

                                           selPath.getLastPathComponent();



    java.lang.Object o = lastComponent.getUserObject();

    TreeNodeInfo tinfo = (TreeNodeInfo)o;

    TreeNode removedOne = lastComponent.getChildAt(0); 

    

    if (isDirDummy(lastComponent))

      {

	//Construct subtree

	String selectedDir = getSelectedItem(selPath);

	

	lastComponent.removeAllChildren();

	int childCnt = updateTree(selectedDir,lastComponent,tinfo.filename);

	

	//announce dummy child is removed

	int[] childIndices = new int[1];

	childIndices[0] = 0;

	TreeNode[] removedChildren = new TreeNode[1];

	removedChildren[0] = removedOne;

	nodesWereRemoved((TreeNode)lastComponent,childIndices,

			  removedChildren);



	//announce some children added to current node	

        childIndices = new int[childCnt];

	for(int i=0;i<childCnt;i++) childIndices[i] = i;

        nodesWereInserted((TreeNode)lastComponent,childIndices);



      }

  }

  

public String getSelectedItem(TreePath selPath)

  {

    int pcount = selPath.getPathCount();

    java.lang.Object pathComponent =  selPath.getPathComponent(pcount-1);

    

   

    String fullPath="";

    for(int i=0;i<pcount;i++){

      TreeNode tn = (TreeNode)(selPath.getPathComponent(i));

      java.lang.Object o = ((DefaultMutableTreeNode)tn).getUserObject();

      TreeNodeInfo tinfo = (TreeNodeInfo)o;

      String append = "";
      if ((tinfo.isDir)||((pcount>1)&&(i==0)))

	append = File.separator;

      fullPath += tinfo.filename+append;

    }

    

    return fullPath;

  }





    public void treeExpanded(TreeExpansionEvent event)
    {
	System.out.println("treeExpanded is Called !!");
	
	TreePath selPath = event.getPath();
	System.out.println("selPath count ="+selPath.getPathCount());
        
	String newDirName = getSelectedItem(selPath);
	System.out.println("newDirName "+newDirName);
	
	if (newDirName.lastIndexOf(File.separator) == newDirName.length() -1){
	    getSelectedDirContent(selPath);
	    System.out.println("Getting Ne directory contents: "+newDirName);
	}
	
    }
    
    public void treeCollapsed(TreeExpansionEvent event)
    {
	System.out.println("treeCollapsed is Called !!");
    }
}


