package WebFlow.gscript;

import WebFlow.*;
import java.io.*;

public class gScriptImpl extends BeanContextChildSupport
                           implements WebFlow.gscript.gScriptOperations {

String msg_;
org.omg.CORBA.Object peer;
private FileWriter fw;
private String ScriptFile, user, gInput, jobdir;

    public gScriptImpl(org.omg.CORBA.Object peer, String msg)
	throws WebFlow.NullPointerException {
    
        super(peer); 
        this.peer = peer;
        msg_ = msg;
    }

    public void test() {
        System.out.println("gScript is up");
    }
    
    public void createScript(String ScriptFile, String user, String gInput,
                             String jobdir) {

      this.ScriptFile = ScriptFile;
      this.user = user;
      this.gInput = gInput;
      this.jobdir = jobdir;

      try {
        fw = new FileWriter(ScriptFile);

        String psedir = "pse";
        String jobfile = psedir+"/"+jobdir+"/job.file";
        String stdout =  psedir+"/"+jobdir+"/stdout.file";
        String stderr =  psedir+"/"+jobdir+"/stderr.file";
        String tmpuser = "/tmp/"+user+"/";
        String TempDir = tmpuser+jobdir; 
     
        setQSUB("-lT 100");        
        setQSUB("-ke");        
        setQSUB("-kj");        
        setQSUB("-ko");        
        setQSUB("-re");        
        setQSUB("-ro");        
        setQSUB("-j "+jobfile);        
        setQSUB("-e "+stdout);        
        setQSUB("-o "+stderr);        
        setQSUB("-r "+psedir);        
        setQSUB("-s /bin/sh");        
        fw.write("\n");

        // goto input directory

        fw.write("INPDIR=$HOME/"+psedir+"/"+jobdir+"\n");
        fw.write("export INPDIR\n");
        fw.write("cd $INPDIR\n");
        fw.write("pwd\n");
        fw.write("\n");

        // create a temporary directory and copy all input files there

        fw.write("mkdir "+tmpuser+"\n");          
        fw.write("TEMPDIR="+TempDir+"\n"); 
        fw.write("export $TEMPDIR\n");
        fw.write("mkdir $TEMPDIR\n");
        fw.write("cp * $TEMPDIR\n");
        fw.write("cd $TEMPDIR\n");
        fw.write("pwd\n");
        fw.write("\n");
    
        // run Gaussian

        fw.write("g94 "+gInput+" $TEMPDIR\n");
        fw.write("\n");

        // move data back to the input directory

        fw.write("cp *.OUT $INPDIR\n");
        fw.write("cp *.chk $INPDIR\n");
 
        // show contents of the input directory

        fw.write("cd $INPDIR\n");
        fw.write("ls -l\n");

        // copy files back to pse.osc.edu

        rcp_pse("gaussian.OUT",user,jobdir); 
        rcp_pse("job.script",user,jobdir); 
        rcp_pse("stdout.file",user,jobdir); 
        rcp_pse("stderr.file",user,jobdir); 
        rcp_pse("job.file",user,jobdir); 

        fw.flush();
        fw.close();


      } catch (IOException ioe) {
         System.out.println("Sorry, cannot open "+ScriptFile+" for write");
         System.out.println(ioe);
      }
    }

      private void setQSUB(String Q) {
        try {
         fw.write("#QSUB "+Q+"\n");
        } catch (IOException ioe) {System.out.println(ioe);}
      }

      private void rcp_pse(String FileName, String User, String JobDir) {
        try {
         String dest="pse@pse.osc.edu:/httpsd/users/"+User+"/"+JobDir+"/.";
         fw.write("rcp "+FileName+" "+dest+"\n");
        } catch (IOException ioe) {System.out.println(ioe);}
      }

}











