package WebFlow.hashtable_jdbc;

import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.util.*;
import WebFlow.jdbc.*;
 

public class ContextDataImpl extends WebFlow.BeanContextChildSupport 
                         implements ContextDataOperations {

  //////////////  Variable Declarations ///////////////////////////
  private Hashtable hashtable;
  String msg_;
  PropertyChangeSupport pcs ;
  VetoableChangeSupport vcs ;
  org.omg.CORBA.Object peer;


  public ContextDataImpl(org.omg.CORBA.Object peer, String msg)
       throws WebFlow.NullPointerException{

  super(peer);
  pcs = new PropertyChangeSupport(peer, this);
  vcs = new VetoableChangeSupport(peer, this);
  this.peer = peer;
  String msg_ = msg;

  System.out.println("HashTable's constructor");
 }

  /////////////   method declaration //////////////////////////////
 
  public boolean contains(String value) {
     return this.hashtable.contains(value);
  }
  
  public boolean containsKey(String key) {
     return this.hashtable.containsKey(key);
  }
 
  public void remove(String key) {
     this.hashtable.remove(key);
  }

  //int size() {     return hashtable.size();  }

  public void test() {
	System.out.println("HashTable is up");
	this.hashtable = new Hashtable();
  }

  public void setParam( Event_Back_DB EventDb ) {
	setParam_hash( EventDb.get_user(), EventDb.get_value() );
  }

  public void setParam_hash( String name, String value ) {
    StringTokenizer name_token = new StringTokenizer( name, "/");
    StringTokenizer value_token = new StringTokenizer( value, "/");
    while( name_token.hasMoreTokens() && value_token.hasMoreTokens() ) {
        String name_temp = name_token.nextToken();
        String value_temp = value_token.nextToken();
		this.hashtable.put( name_temp, value_temp );
	}
  }

  public String getParam(String name) {
	StringBuffer value= new StringBuffer();
	StringTokenizer name_token = new StringTokenizer( name, "/");
    try {
		while( name_token.hasMoreTokens() ){
			String name_temp = name_token.nextToken();
			java.lang.Object obj = this.hashtable.get( name_temp );
			if (obj!=null) 
				value.append( ( String ) obj + "/" );
		}
    } 
	catch (Exception e) {
		System.out.println(e+"while getParam");
	}//catch
    return value.toString();
  }

  public void rmParam(String name) {
    StringTokenizer name_token = new StringTokenizer( name, "/");
    while( name_token.hasMoreTokens() ){
		String name_temp = name_token.nextToken();
		hashtable.remove( name_temp );
	}
  }

  public String[] getKeys() {
	int n = this.hashtable.size();
    String[] Keys = new String[n];
    Enumeration K = this.hashtable.keys();
    int i= 0;
    while(K.hasMoreElements()) {
		Keys[i]=(String)K.nextElement();
        i++;
	}
    return Keys;
  }//method

  public void putParam( String name, String value ) {
	StringTokenizer name_token = new StringTokenizer( name, "/");
    StringTokenizer value_token = new StringTokenizer( value, "/");
	int i = value_token.countTokens();
	String[] temp = new String[ i ]; 
	int n = 0;
   while( name_token.hasMoreTokens() && value_token.hasMoreTokens() ) {
        String name_temp = name_token.nextToken();
        String value_temp = value_token.nextToken();
		temp[ n ] = value_temp;
		n++;
        System.out.println( "Send to database: " + name_temp + "," + value_temp);
    }//while
	Event_Get_Hash put_database = new Event_Get_HashImpl( getBeanContextChildPeer() );
    put_database.set_user( temp[ 0 ] ); 
	put_database.set_project( temp[ 1 ] );
	put_database.set_sessions( temp[ 2 ] );
	put_database.set_application( temp[ 3 ] );
	put_database.set_param( temp[ 4 ] );
	put_database.set_value( temp[ 5 ] );
	fireEvent( "submit", put_database );
  }//method

  public void restoreAll( String name, String value ) {
    StringTokenizer name_token = new StringTokenizer( name, "/");
    StringTokenizer value_token = new StringTokenizer( value, "/");
    int i = value_token.countTokens();
    String[] temp = new String[ i ];
    int n = 0;
   while( name_token.hasMoreTokens() && value_token.hasMoreTokens() ) {
        String name_temp = name_token.nextToken();
        String value_temp = value_token.nextToken();
        temp[ n ] = value_temp;
        n++;
    }//while
	Event_Restore restore_hashtable = new Event_RestoreImpl( getBeanContextChildPeer() );
//	Event_Resotre restore_hashtable = new Event_Resotre( temp[ 0 ], temp[ 1 ], temp[ 2 ], temp[ 3 ] );
    restore_hashtable.set_user( temp[ 0 ] );
	restore_hashtable.set_project( temp[ 1 ] );
	restore_hashtable.set_sessions( temp[ 2 ] ); 
	restore_hashtable.set_application( temp[ 3 ] );
    fireEvent( "restore", restore_hashtable );
  }//method

}







