package WebFlow.hashtable;

import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.util.*;
import java.io.*; 

public class SaveContextImpl extends WebFlow.BeanContextChildSupport 
                         implements SaveContextOperations {

  String msg_;
  org.omg.CORBA.Object peer;
  boolean debug = true;

  public SaveContextImpl(org.omg.CORBA.Object peer, String msg)
       throws WebFlow.NullPointerException{

  super(peer);
  this.peer = peer;
  String msg_ = msg;
 }

  public void test(){
   System.out.println("SaveContext is up");
  } 

  public void saveContextData(WebFlowContext context){
      ContextData cd = findContextData(context);
      System.out.println("get Keys"); 
      String[] Keys = cd.getKeys();
      int n = Keys.length;
      System.out.println("number of Keys: "+n);
      String curDir=cd.getParam("Directory")+File.separator+"ContextData.txt";
      System.out.println(curDir);
      if(n>0) { 

      try {
           FileWriter fw = new FileWriter(curDir);       
           for(int i=0;i<n;i++){
             fw.write(Keys[i]+" "+cd.getParam(Keys[i])+"\n");
	   }
           fw.flush();
           fw.close();
      }
      catch (Exception e) {System.out.println(e);}  
      }
      else {
       System.out.println("oops, nothing to save!");
      }
  }

  public void restoreContextData(WebFlowContext context, String DDir){
     ContextData cd = findContextData(context);
     String curDir=DDir+"USER"+File.separator;
     System.out.println("restore: "+curDir); 

     // find location of the saved file
     String ID = context.getObjectID();  
             // remove master's name
     System.out.println("ID="+ID);
     int    idx = ID.indexOf(File.separator);
            ID = ID.substring(idx+1);
	    //  extract user's name
            idx = ID.indexOf(File.separator);
            if(idx<0) {
               curDir += ID;
            }
            else {    
               curDir += ID.substring(0,idx);
               ID = ID.substring(idx+1);
     System.out.println("ID="+ID);
            // the rest of the context hierarchy
            idx = ID.indexOf(File.separator);
	    while (idx>-1) {
               String name = ID.substring(0,idx);
     System.out.println("name="+name);
                  int idx2 = name.indexOf(".");
     System.out.println(idx2); 
                      name = name.substring(0,idx2);
     System.out.println("name="+name);
                      curDir += File.separator+name;
                      ID = ID.substring(idx);  
     System.out.println("ID="+ID);
                      idx = ID.indexOf(File.separator);
     System.out.println(idx); 
		      }
            curDir += File.separator+ID; 
	    }
     System.out.println("Directory is "+curDir); 
     
     try { 
     FileReader fr = new FileReader(curDir+File.separator+"ContextData.txt");
     BufferedReader in = new BufferedReader(fr);
     String nextLine="";
     StringTokenizer st;
     while((nextLine=in.readLine()) != null) {  
        st=new StringTokenizer(nextLine);
        String Name=st.nextToken();
        String Value=st.nextToken();
        System.out.println(Name+"="+Value);
     }
     } catch (Exception e) {System.out.println(e);}  
  }


  public void setContextData(WebFlowContext c, String name, String value){
         ContextData cd = findContextData(c);
         cd.setParam(name,value);
     }    

  public String getContextData(WebFlowContext c, String name) {
          ContextData cd = findContextData(c);
          String value = cd.getParam(name); 
          return value;
     }

  public ContextData findContextData(WebFlowContext wfc) {
          ContextData wfcContextData=null;

          String ContextDataName = wfc.getObjectID()+"/ContextData";
          org.omg.CORBA.Object o = wfc.getKeyedChild(ContextDataName);
          if(o != null) {
          wfcContextData = ContextDataHelper.narrow(o); 
	  } else {System.out.println("Context data not found!");}

	  if(wfcContextData==null) {
            System.out.println("Context data not found!");
	  }
        return wfcContextData;
       }
 
}







