package WebFlow.jdbc;

import java.sql.*;
import java.io.*;
import WebFlow.hashtable_jdbc.*; 
import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;

public class Oracle_Impl extends WebFlow.BeanContextChildSupport implements JdbcOperations{

  private Connection conn;//for connection with JDBC
  String msg_;
  PropertyChangeSupport pcs ;
  VetoableChangeSupport vcs ;
  org.omg.CORBA.Object peer;


  public Oracle_Impl(org.omg.CORBA.Object peer, String msg)
       throws WebFlow.NullPointerException{

  super(peer);
  pcs = new PropertyChangeSupport(peer, this);
  vcs = new VetoableChangeSupport(peer, this);
  this.peer = peer;
  String msg_ = msg;
  }

  private void connect() {
    try {
    Class.forName("oracle.jdbc.driver.OracleDriver");//get drive.
    //get connection with JDBC
    conn = DriverManager.getConnection("jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe" , "gangwei", "gangwei");
    }
    catch( Exception exc ){
        System.out.println( "IOException " + exc.getMessage() );
        exc.printStackTrace();
    }
  }

  private void close() {
    try {
         conn.close();
    }
    catch (Exception e) {
        System.out.println( "IOException " + e.getMessage() );
        e.printStackTrace();
    }
  }

  public void test() {
	System.out.println( "This is database." );
  }

  public void makeRecord( Event_Get_Hash put_database ){

	String key = "1";
	try{
		connect();
        String s_param = "insert into param_table " + "( key, user_name, project, sessions, application, param, value )" + "values ( ?, ?, ?, ?, ?, ?, ? )";
        PreparedStatement pstmt_param = conn.prepareStatement( s_param );
        pstmt_param.setString( 1, key );
        pstmt_param.setString( 2, put_database.get_user() );
        pstmt_param.setString( 3, put_database.get_project() );
        pstmt_param.setString( 4, put_database.get_sessions() );
        pstmt_param.setString( 5, put_database.get_application() );
        pstmt_param.setString( 6, put_database.get_param() );
        pstmt_param.setString( 7, put_database.get_value() );

        int r = pstmt_param.executeUpdate( s_param );
        pstmt_param.close();

        System.out.println( "Inserting is successful." );
		close();
    }
    catch (Exception exc) {
        System.out.println( "IOException " + exc.getMessage() );
        exc.printStackTrace();
    }
  }//method


 public void deleteRecord( String user_name, String project, String sessions ) {
	int r;
	PreparedStatement pstmt_param;

	try{

		connect();
	    String s_param = "delete from param_table " + "where user_name = ? and project = ? and session = ?";
	    pstmt_param = conn.prepareStatement( s_param);
	    pstmt_param.setString( 1, user_name );
	    pstmt_param.setString( 2, project );
	    pstmt_param.setString( 3, sessions );

	    r = pstmt_param.executeUpdate( s_param );
	    pstmt_param.close();

	    System.out.println( "Deleting is sucessful." );
		close();
	}
    catch (Exception exc) {
        System.out.println( "IOException " + exc.getMessage() );
        exc.printStackTrace();
	}//if

  }//method

 public void findRecord( Event_Restore restore_hashtable ){
    StringBuffer _stringbuffer = new StringBuffer();
	try{
        connect();
		System.out.println( "Select the param_table:user = " + restore_hashtable.get_user() + "project = " + restore_hashtable.get_project() );
		String s_param = "select * from param_table " + "where user_name = ? and project = ? and sessions = ? and application = ?";
		PreparedStatement pstmt_param;
		pstmt_param = conn.prepareStatement( s_param);
		pstmt_param.setString( 1, restore_hashtable.get_user() );
		pstmt_param.setString( 2, restore_hashtable.get_project() );
		pstmt_param.setString( 3, restore_hashtable.get_sessions() );
		pstmt_param.setString( 4, restore_hashtable.get_application() );
		ResultSet rs = null;
		rs = pstmt_param.executeQuery();

		while( rs.next() ){
			_stringbuffer.append( rs.getString( 2 ) + "/" );
			_stringbuffer.append( rs.getString( 3 ) + "/" );
			_stringbuffer.append( rs.getString( 4 ) + "/" );
			String temp = null;
			temp = rs.getString( 5 );
			if( temp.equals( "" ) || temp.equals( null ) )
				_stringbuffer.append( "null" + "/" );
			else 
				_stringbuffer.append( temp + "/" );
            temp = null;
            temp = rs.getString( 6 );
            if( temp.equals( "" ) || temp.equals( null ) )
                _stringbuffer.append( "null" + "/" );
            else
                _stringbuffer.append( temp + "/" );
            temp = null;
            temp = rs.getString( 7 );
            if( temp.equals( "" ) || temp.equals( null ) )
                _stringbuffer.append( "null" );
            else
                _stringbuffer.append( temp );

		}//while
		pstmt_param.close();
        close();
    }//try
    catch (Exception exc) {
        System.out.println( "IOException " + exc.getMessage() );
        exc.printStackTrace();
    }
	System.out.println( "The database result: " + _stringbuffer.toString());
	WebFlow.hashtable_jdbc.Event_Back_DB EventDb = new WebFlow.hashtable_jdbc.Event_Back_DBImpl( getBeanContextChildPeer() );
	EventDb.set_user( "user/project/sessions/application/param/value");
	EventDb.set_value( _stringbuffer.toString() );
	fireEvent( "back", EventDb );

  }//method
}//class
