package WebFlow.lms; 
import WebFlow.*; 
import WebFlow.event.*; 
import org.omg.CORBA.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import java.net.*; 
import java.util.*;

public class Client
{
   public static void main(String args[])
   {
      configReader config ; 

 if(args.length !=1) {
           System.out.println("Usage:");
           System.out.println("   WebFlow.JobService.Client url");
           System.out.println("     url - url to the master's IOR");
           System.exit(1);
	 }    

  try{

   //  Create ORB
   Properties props = System.getProperties();
   props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
   props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
   System.setProperties(props);
   ORB orb = ORB.init(args, props);

         //  Connect to the master server

         String masterURL = args[0] ; 
         String ref ; 
         org.omg.CORBA.Object obj = null ; 
      
         System.out.println(" masterURL : "+masterURL); 

         ref = getIORFromURL(masterURL); 

         System.out.println("REF: "+ref); 

         obj = orb.string_to_object(ref); 

         if(obj == null)
              throw new RuntimeException(); 

         WebFlowContext ws =  WebFlowContextHelper.narrow(obj);
         System.out.println("Clinet: got master "+ws);
  
         if(ws == null)
               throw new RuntimeException(); 
         
          WebFlowContext s1 =
          WebFlowContextHelper.narrow(ws.getContext("lms_master/casc2d.server.osprey4"));
          System.out.println("Client: got casc2d server "+s1); 

          org.omg.CORBA.Object p1 = s1.addNewModule("runCasc2d"); 
          runCasc2d casc2d = runCasc2dHelper.narrow(p1);  

          System.out.println("try invoke casc2d");
          casc2d.run();

      /* Client register events to specify which module an event comes from,           which module and what method an event is received by 

         s1.attachPushEvent(p1, "Fire_Button" , k1 , "getEvent"); 
         s1.attachPushEvent(p1 , "Reset_Button" , k1, "getEvent"); 
         s1.attachPushEvent(p1 , "Quit_Button" , k1 , "getEvent"); 
      */

      }
       catch(COMM_FAILURE ex)
       {
            System.err.println(ex.getMessage());
            ex.printStackTrace();
            System.exit(1);
       }
  } 

   static public String getIORFromURL(String url) {

   System.out.println("Slave WebFlow is getting IOR from url:"+url); 
   String masterServerIOR =""; 
   String thisLine = null ; 

   // Open the URL for reading 
 
   try{
        URL u = new URL(url); 

        // now turn the URL into a DataInputStream

        try{
         DataInputStream theHTML = new DataInputStream(u.openStream());

          while((thisLine = theHTML.readLine()) != null){ 
             masterServerIOR += thisLine ; 
          } 
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
        }
     }
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
     }
    return masterServerIOR ; 
  }

  static public void listContents(org.omg.CORBA.Object context)
 {
    WebFlowContext wfc = WebFlowContextHelper.narrow(context);
 
    System.out.println("This context has the following childs:"); 
    System.out.println(" "+wfc.getObjectID()); 
  
    org.omg.CORBA.Object []list = wfc.toArray(); 
    System.out.println("This Context has :"+list.length+"children.."); 

    for(int k=0; k < list.length; k++){
       BeanContextChild bcc = BeanContextChildHelper.narrow(list[k]); 
       String id = bcc.getObjectID(); 
       System.out.println("Next Child:"+id); 
    }
  }

}
