package WebFlow.oracle;

import WebFlow.*; 
import WebFlow.event.*; 
import java.awt.*;
import java.io.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.net.*; 
import java.util.*;
import org.omg.CORBA.*;

public class jdbc_Client extends Frame {

  public ControlPanel controlPanel;//buttons
  public Panel headerPanel;
  public DisplayPanel dp;//display area
  private ORB orb;
  private org.omg.CORBA.Object obj;
  private Data_Storage s;
  private static Oracle oracleImpl;

   public static void main(String args[])
   {
      configReader config ; 

      try
      {
         //  Create ORB
         Properties props = System.getProperties();
         props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
         props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
            System.setProperties(props);

            ORB orb = ORB.init(args, props);


         //  Connect to the master server

         if(args.length !=1) {
           System.out.println("Usage:");
           System.out.println("   WebFlow.JobService.Client url xml");
           System.out.println("     url - url to the master's IOR");
           System.exit(1);
         }    

         String masterURL = args[0] ; 
    
         String ref ; 
         org.omg.CORBA.Object obj = null ; 
         System.out.println(" masterURL : "+masterURL); 

         ref = getIORFromURL(masterURL); 
         System.out.println("REF: "+ref); 

         obj = orb.string_to_object(ref); 

         if(obj == null)
              throw new RuntimeException(); 
         WebFlowContext ws =  WebFlowContextHelper.narrow(obj);
         System.out.println("Clinet: got master "+ws);
  
         if(ws == null)
               throw new RuntimeException(); 

         System.out.println("attach event"); 
         org.omg.CORBA.Object p1 = ws.addNewModule("Oracle"); 
         System.out.println("narrow"); 
    	oracleImpl = OracleHelper.narrow( p1 );
		new jdbc_Client();
      }
	 catch(COMM_FAILURE ex) {
        System.out.println("Command_Error: "+ex); 

        System.err.println(ex.getMessage()); 
        ex.printStackTrace(); 
        System.exit(1); 
       }  
  }//method

   static public String getIORFromURL(String url) {
   System.out.println("Slave WebFlow is getting IOR from url:"+url); 
   String masterServerIOR =""; 
   String thisLine = null ; 

   // Open the URL for reading 
 
   try{
        URL u = new URL(url); 

        // now turn the URL into a DataInputStream

        try{
         DataInputStream theHTML = new DataInputStream(u.openStream());

          while((thisLine = theHTML.readLine()) != null){ 
             masterServerIOR += thisLine ; 
          } 
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
        }
     }
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
     }
    return masterServerIOR ; 
  }




 /**Input:void
    Output:void
    Function:Initilize the screen.
 **/
  public jdbc_Client() {
	super( "JDBC CORBA" );
	setSize( 600, 450 );
    // set background color to lightGray, add HeaderPanel,
    //DisplayPanel and controlPanel components
    setBackground(Color.pink);
    headerPanel = new Panel();
    headerPanel.setFont(new Font("Helvetica", Font.PLAIN, 24));
    headerPanel.add(new Label("CORBA Database Connectivity"));
    add("North", headerPanel);
    add("Center", dp = new DisplayPanel());//display area
    //buttons!
    add("South",  controlPanel = new ControlPanel(this));
	setVisible( true );
	show();

  }

  public void search( Data_Storage temp_storage ){
	System.out.println( "Looking for " + temp_storage.name );
	dp.showResult( oracleImpl.findRecord( temp_storage ) );
	System.out.println("got back from db." );
  }

  public void adddate( Data_Storage temp_storage ){
	if( temp_storage.name.equals( "null" ) || temp_storage.application.equals( "null" ) || temp_storage.appDesc.equals( "null" ) || temp_storage.simpleName.equals( "null" ) )
		dp.showerr( 1 );
	else{
		oracleImpl.makeRecord( temp_storage );
		dp.showOk( 1 );
	}
  }

   public void delete_date( Data_Storage temp_storage ) {
	if( temp_storage.name.equals( "null" ) || temp_storage.application.equals( "null" ))
		dp.showerr( 2 );
	else {
		oracleImpl.deleteRecord( temp_storage ); 
		dp.showOk( 2 );
	}
   }

  public void destory() {
	oracleImpl.close();
	dp.showOk( 3 );
	System.exit( 1 );
  }

  public void open() {
	oracleImpl.connect();
	dp.showOk( 4 );
  }
}//class

/** The ControlPanel with two panels, connectionPanel with insert, delete,
    update, search, clear, and close buttons; searchPanel with labels and
    textfields which provide to client type in.
 API:
   ControlPanel( Client );
   actionPerformed( ActionEvent );
 */
class ControlPanel extends Panel implements ActionListener {

  private jdbc_Client parent;
  private TextField name, application, directory, appDesc, simpleName,
input, output, job;
  private Label lbl;
  private Panel searchPanel;
  private Panel connectionPanel;
  private Button open, closeButton, searchPro, clearButton, insert, delete;
  private Data_Storage s;

  /**Input:Client obj.
     Output:void
     Function:initialize the screen.
  **/
  public ControlPanel( jdbc_Client clt) {

    parent = clt;
    setLayout(new BorderLayout());
    setFont(new Font("Helvitica", Font.PLAIN, 14));
    searchPanel = new Panel();
    searchPanel.setLayout( new GridLayout( 8, 2 ) );
    connectionPanel = new Panel();

    delete = new Button( "Delete Process" );
    closeButton = new Button("Close Connection");
    insert = new Button("Add Process");
    searchPro = new Button("Search Process");
    clearButton = new Button("Clear");
	open = new Button( "Open Connection" );
    insert.addActionListener(this);
    delete.addActionListener( this );
    closeButton.addActionListener(this);
    searchPro.addActionListener(this);
    clearButton.addActionListener(this);
	open.addActionListener( this );
	
	connectionPanel.add( open );
	connectionPanel.add( insert );
	connectionPanel.add( searchPro );
	connectionPanel.add( delete );
	connectionPanel.add( closeButton );
	connectionPanel.add( clearButton );

    searchPanel.add( new Label("User Name"));
    searchPanel.add( name = new TextField(20));
    searchPanel.add( new Label("Process Application"));
    searchPanel.add( application = new TextField( 20 ) );
    searchPanel.add( new Label( "Directory" ));
    searchPanel.add( directory = new TextField( 20 ) );
    searchPanel.add( new Label( "Application Describation" ));
    searchPanel.add( appDesc = new TextField( 20 ) );
    searchPanel.add( new Label( "Simple Application Name" ));
    searchPanel.add( simpleName = new TextField( 20 ) );
    searchPanel.add( new Label( "Output File" ));
    searchPanel.add( output = new TextField( 20 ) );
    searchPanel.add( new Label( "Input File" ));
    searchPanel.add( input = new TextField( 20 ) );
    searchPanel.add( new Label( "Job Name" ));
    searchPanel.add( job = new TextField( 20 ) );

    add("North",connectionPanel);
    add("South",searchPanel);
  }

  /**Input:ActionEvent obj.
     Output:void
     Function:waiting something happen.
  **/
  public void actionPerformed(ActionEvent event) {
    String buttonLabel = event.getActionCommand();

    if(buttonLabel.equals("Search Process")) {
    try {
		System.out.println("search for job: " + job.getText() );
    	s = new Data_Storage( "null", "null", "null", "null", "null", "null", "null", "null" );
    //look for the process information.
		if( !(name.getText().equals( "" )) )
			s.name = name.getText();
		if( !( application.getText().equals( "" )) )
			s.application = application.getText();
		 parent.search( s );
	}
	catch (Exception ex) {
      }
    }//if search

   if(buttonLabel.equals("Delete Process")) {
      try {
        System.out.println("Delete Process " + job.getText() );
        s = new Data_Storage( "null", "null", "null", "null", "null", "null", "null", "null" );
    //look for the process information.
        if( !(name.getText().equals( "" )) )
            s.name = name.getText();
		if( !( application.getText().equals( "" )) )
			s.application = application.getText();
		parent.delete_date( s );
		}
    catch (Exception ex) {
      }
    }//if delete 

    if(buttonLabel.equals("Add Process")) {
      try {
       System.out.println("Add Process" + job.getText() );
        s = new Data_Storage( "null", "null", "null", "null", "null", "null", "null", "null" );
    //look for the process information.
        if( !(name.getText().equals( "" )) )
            s.name = name.getText();
        if( !( application.getText().equals( "" )) )
            s.application = application.getText();
        if( !( appDesc.getText().equals( "" )) )
			s.appDesc = appDesc.getText();
        if( !( simpleName.getText().equals( "" )) )
			s.simpleName = simpleName.getText();
        parent.adddate( s );
        }
    catch (Exception ex) {
      }
    }//if add

   //clean the textfield.
    if(buttonLabel.equals("Clear")) {
		name.setText("");
		application.setText("");
		directory.setText("");
		appDesc.setText("");
		simpleName.setText("");
		input.setText("");
		output.setText("");
		job.setText("");
	}

  //close connection with database.
    if(buttonLabel.equals("Close Connection")) {
		parent.destory();
	}

  //open the database
	if( buttonLabel.equals( "Open Connection" ) )
		parent.open();

  }//method
}//class

/** the DisplayPanel contains a textarea to display the results of our
search
  API:
   DisplayPanel();
   showResult( String, String, String, String, String, String, String,
String );
   showerr( int );
 */
class DisplayPanel extends Panel {
  TextArea resultArea;
  String nodata = "Sorry! There is no such process by that name.";
  String typedata = "Sorry! You should type in User Name, Application, Application Describation, and Simple Application Name."; 
  String namedata = "Sorry! You should type in User Name, Application.";


  /**Input:void.
     Output:void,
     Function:initialize the display area.
  **/
  public DisplayPanel() {
    setLayout(new BorderLayout(10,10));
    resultArea = new TextArea(15,60);
    resultArea.setBackground(Color.white);
    add("Center",resultArea);
  }

  public void showResult( Data_Storage[] data ){
	resultArea.setFont( new Font("Times-Roman",Font.PLAIN,16));
    setForeground(Color.black);
	int i = 0;
	StringBuffer _stringbuffer = new StringBuffer();
	for( i = 0; i < data.length; i++ ){
		Data_Storage temp;
		temp = data[ i ];
		_stringbuffer.append( "User Name: " + temp.name + "\n" );
        _stringbuffer.append( "Application: " + temp.application + "\n" );
        _stringbuffer.append( "Directory: " + temp.directory + "\n" );
        _stringbuffer.append( "Application Describation: " + temp.appDesc + "\n" );	
        _stringbuffer.append( "Application Name: " + temp.simpleName + "\n" );
        _stringbuffer.append( "Input File: " + temp.input + "\n" );
        _stringbuffer.append( "Output File: " + temp.output + "\n" );
        _stringbuffer.append( "Job Name: " + temp.job + "\n" );
	}
	if( i == 0 ){
      resultArea.setFont( new Font("Times-Roman",Font.PLAIN,18));
      setForeground(Color.red);
      resultArea.setText("\n\n\n " + nodata);
    }
	else 
		resultArea.setText( _stringbuffer.toString() );
  }//method

  public void showerr( int a ) {
    if( a == 1 ){//shoe the error of time be forgotten.
      resultArea.setFont( new Font("Times-Roman",Font.PLAIN,18));
      setForeground(Color.red);
      resultArea.setText("\n\n\n " + typedata);
    }
    else{
      resultArea.setFont( new Font("Times-Roman",Font.PLAIN,18));
      setForeground(Color.red);
      resultArea.setText("\n\n\n " + namedata );
    }
  }//method

  public void showOk( int a ) {
	resultArea.setFont( new Font("Times-Roman",Font.PLAIN,16));
    setForeground(Color.black);
	if( a == 1 ) 
		resultArea.setText( "Inserting is successful." );
	else if( a == 2 )
		resultArea.setText( "Deleting is successful." );
	else if( a == 3 )
		resultArea.setText( "Connection with database is close." );
	else
		resultArea.setText( "Connection with database is open." ); 
  }//method
}//class
	








