package WebFlow.oracle;

import java.sql.*;
import java.io.*;
import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;

public class jdbc_Impl extends WebFlow.BeanContextChildSupport implements OracleOperations {
  private Connection conn;//for connection with JDBC
  String msg_;
  PropertyChangeSupport pcs ;
  VetoableChangeSupport vcs ;
  org.omg.CORBA.Object peer;


  public jdbc_Impl(org.omg.CORBA.Object peer, String msg)
       throws WebFlow.NullPointerException{

  super(peer);
  pcs = new PropertyChangeSupport(peer, this);
  vcs = new VetoableChangeSupport(peer, this);
  this.peer = peer;
  String msg_ = msg;
  }


  public void connect() {
	try {
    Class.forName("oracle.jdbc.driver.OracleDriver");//get drive.
    //get connection with JDBC
    conn = DriverManager.getConnection("jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe" , "gangwei", "gangwei");
	}
	catch( Exception exc ){
		System.out.println( "IOException " + exc.getMessage() );
		exc.printStackTrace();
	}
  }

  public void close() {
	try {
   		 conn.close();
    }
    catch (Exception e) {
		System.out.println( "IOException " + e.getMessage() );
        e.printStackTrace();
	}
  }

  public void makeRecord( Data_Storage temp_storage ){
	try{
		String s_context = "insert into context_table " + "( name, application, appdesc, simplename, inputf, target, job )" + "values ( ?, ?, ?, ?, ?, ?, ? )"; 
		String s_project3 = "insert into project3_table " + "( name, application, directory )" +  "values ( ?, ?, ? )";
		PreparedStatement pstmt_context = conn.prepareStatement( s_context);
		pstmt_context.setString( 1, temp_storage.name );
		pstmt_context.setString( 2, temp_storage.application );
		pstmt_context.setString( 3, temp_storage.appDesc );
		pstmt_context.setString( 4, temp_storage.simpleName );
		pstmt_context.setString( 5, temp_storage.input );
		pstmt_context.setString( 6, temp_storage.output );
		pstmt_context.setString( 7, temp_storage.job );
		
		int r = pstmt_context.executeUpdate( s_context );
		pstmt_context.close();
		
		 PreparedStatement pstmt_project3 = conn.prepareStatement( s_project3 );
		pstmt_project3.setString( 1, temp_storage.name );
		pstmt_project3.setString( 2, temp_storage.application );
		pstmt_project3.setString( 3, temp_storage.directory );

		r =  pstmt_project3.executeUpdate( s_project3 );
		pstmt_project3.close();

		System.out.println( "Inserting is successful." );
	}
    catch (Exception exc) {
        System.out.println( "IOException " + exc.getMessage() );
        exc.printStackTrace();
    }
  }//method

  public void deleteRecord( Data_Storage temp_storage ) {
	try{
		String s_context = "delete from context_table " + "where name = ? and application = ?";
		String s_project3 = "delete from project3_table " + "where name = ? and application = ?";
		PreparedStatement pstmt_context = conn.prepareStatement( s_context);
		pstmt_context.setString( 1, temp_storage.name );
        pstmt_context.setString( 2, temp_storage.application );

        int r = pstmt_context.executeUpdate( s_context );
        pstmt_context.close();

		PreparedStatement pstmt_project3 = conn.prepareStatement( s_project3 );
		pstmt_project3.setString( 1, temp_storage.name );
        pstmt_project3.setString( 2, temp_storage.application );

        r =  pstmt_project3.executeUpdate( s_project3 );
        pstmt_project3.close();

		System.out.println( "Deleting is sucessful." );
	}
    catch (Exception exc) {
        System.out.println( "IOException " + exc.getMessage() );
        exc.printStackTrace();
    }
  }//method

  public Data_Storage[] findRecord( Data_Storage temp_storage ){
	java.util.Vector vector = new java.util.Vector();
	try{
		if(  temp_storage.application.equals( "null" ) )
		{
			System.out.println( "Select the project3_table." + temp_storage.name );
			String s_project3 = "select * from project3_table " + "where name = ?";
			PreparedStatement pstmt_project3 = conn.prepareStatement( s_project3 );	
			pstmt_project3.setString( 1, temp_storage.name );
			ResultSet rs_project3 = null;
			rs_project3 = pstmt_project3.executeQuery();

			while( rs_project3.next() ){
				Data_Storage temp = new Data_Storage( "null", "null", "null", "null", "null", "null", "null", "null");
				temp.name = temp_storage.name;
				temp.application = rs_project3.getString( 2 );
				String _string = rs_project3.getString( 3 );
				if( !(  _string.equals( "" ) ) || !( _string.equals( null ) ) )
					temp.directory = _string; 
				vector.addElement( temp );
			}
			pstmt_project3.close();
		}
		else{
			System.out.println( "Select the context_table." + temp_storage.name + temp_storage.application );
			String s_context = "select * from context_table " + "where name = ? and application = ?";
			PreparedStatement pstmt_context = conn.prepareStatement( s_context );
			pstmt_context.setString( 1, temp_storage.name );
			pstmt_context.setString( 2, temp_storage.application );
			ResultSet rs_context = null;
			rs_context = pstmt_context.executeQuery( );

            while( rs_context.next() ){
                Data_Storage temp = new Data_Storage( "null", "null", "null", "null", "null", "null", "null", "null");
                temp.name = temp_storage.name;
				temp.application = temp_storage.application;
				temp.appDesc = rs_context.getString( 3 );
				temp.simpleName = rs_context.getString( 4 );
				String _context = rs_context.getString( 5 );
				if( _context != null )
					temp.input = _context;
				_context = rs_context.getString( 6 );
				if( _context != null )
					temp.output = _context;
				_context = rs_context.getString( 7 );
				if( _context != null )
					temp.job = _context;	
				vector.addElement( temp );
			}
			pstmt_context.close();
		}//else
	}
    catch (Exception exc) {
        System.out.println( "IOException " + exc.getMessage() );
        exc.printStackTrace();
    }

    Data_Storage objectArray[] = new Data_Storage[ vector.size() ];
    for( int j = 0; j < vector.size(); j++ )
        objectArray[ j ] = ( Data_Storage ) vector.elementAt( j );

    return objectArray;

  }//method

}//class
			
				



