package WebFlow.RemoteFile;

import java.io.*;
import WebFlow.RemoteFile.RemoteFilePackage.*;
import WebFlow.event.*;
import WebFlow.*;

public class MoveFileImp extends WebFlow.BeanContextChildSupport
    implements MoveFileOperations
{
    private FileTransfer ft = null;
    private org.omg.CORBA.Object ppeer;
    private String dest_file = null;
    
    public MoveFileImp(org.omg.CORBA.Object peer, String msg)
	throws WebFlow.NullPointerException
    {
	super(peer);
	ppeer = peer;
    }
    
    public void Init(String remote_file_ior)
    {
	org.omg.CORBA.ORB orb = getMyProxy()._orb();// = org.omg.CORBA.ORB.init();
	ft = new FileTransfer(orb, remote_file_ior);
    }

    public void Init(RemoteFile rf)
    {
	ft = new FileTransfer(rf);
    }
    
    public void FileSend(String dest, String source)
    {
	try {
	    ft.FileSend(source, dest);
	} 
	catch (java.io.IOException ex) { 
	    System.out.println("**ERROR: MoveFile.FileSend -> " + ex); 
	}
	catch (FileException ex) {
	    System.out.println("**ERROR: MoveFile.FileSend -> " + ex); 
	};
    }

    public void FileReceive(String dest, String source)
    {
	try {
	    ft.FileReceive(dest, source);
	} 
	catch (java.io.IOException ex) {
	    System.out.println("**ERROR: MoveFile.FileReceive -> " + ex); 
	}
	catch (FileException ex) {
	    System.out.println("**ERROR: MoveFile.FileReceive -> " + ex); 
	};
    }

    public void test()
    {
	trace("Move file is OK");
    }

    private void trace(String msg)
    {
	System.out.println("**MOVE FILE: " + msg);
    }
    
    private void error(String msg)
    {
	System.out.println("**ERROR in MOVE FILE: " + msg);
    }
}
