// **********************************************************************
//
// Generated by the ORBacus IDL to Java Translator
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

// Version: 3.1.2
// License: non-commercial

package WebFlow.QS;

//
// IDL:WebFlow/QS/RemoteFile:1.0
//
/**
 *
 * Component that is used to read and write remote file
 *
 **/
public interface RemoteFile extends WebFlow.BeanContextChild
{

    //
    // IDL:WebFlow/QS/RemoteFile/open:1.0
    //
    /**
     *
     * open file with the specified name.
     *
     * @param file_name name of the file to open.
     *
     * @param options is "r" to open file for reading or "rw" to ope
     *
     *  file for reading and writing
     **/
    public void
    open(String file_name,
         String options)
        throws WebFlow.QS.RemoteFilePackage.FileException;

    //
    // IDL:WebFlow/QS/RemoteFile/close:1.0
    //
    /**
     *
     * close opened file.
     *
     **/
    public void
    close();

    //
    // IDL:WebFlow/QS/RemoteFile/getBlock:1.0
    //
    /**
     *
     * get block of data from the opened file, use arr.length to get number of bytes read
     *
     * @param arr sequence of bytes that is read by component
     *
     * @exception WebFlow.QS.RemoteFilePackage.EOFFileException is raised if end of file is reached
     *  
     **/
    public byte[]
    getBlock()
        throws WebFlow.QS.RemoteFilePackage.FileException,
               WebFlow.QS.RemoteFilePackage.EOFFileException;

    //
    // IDL:WebFlow/QS/RemoteFile/get:1.0
    //
    /**
     *
     * get one octet (byte) from the file and returns it to the user
     *
     * @param c octet to return read byte to the user
     *  
     * @exception WebFlow.QS.RemoteFilePackage.EOFFileException is raised if end of file is reached
     *
     **/
    public void
    get(org.omg.CORBA.ByteHolder c)
        throws WebFlow.QS.RemoteFilePackage.FileException,
               WebFlow.QS.RemoteFilePackage.EOFFileException;

    //
    // IDL:WebFlow/QS/RemoteFile/putBlock:1.0
    //
    /**
     *
     * write block of octets to the file
     *
     * @param arr is a sequence of octets to be filled by the user
     *  
     **/
    public void
    putBlock(byte[] arr)
        throws WebFlow.QS.RemoteFilePackage.FileException;

    //
    // IDL:WebFlow/QS/RemoteFile/put:1.0
    //
    /**
     *
     * write one octet to the file
     *
     * @param c octet to write that user supplies to the function
     *  
     **/
    public void
    put(byte c)
        throws WebFlow.QS.RemoteFilePackage.FileException;

    //
    // IDL:WebFlow/QS/RemoteFile/setBlockSize:1.0
    //
    /**
     *
     * set block size for reading file
     *
     * @param aSize size of the block of octets to be read at one time
     *  
     **/
    public void
    setBlockSize(short aSize);

    //
    // IDL:WebFlow/QS/RemoteFile/getFileSize:1.0
    //
    public int
    getFileSize()
        throws WebFlow.QS.RemoteFilePackage.FileException;
}
