package WebFlow.test;

import WebFlow.*;
import WebFlow.event.*;
 
import org.omg.CORBA.*;
import java.io.*;
import java.util.*;


/**
//Each WebFlow server will initiate its own IR server.
//We will use IR in two place:
//1- When adapter got one event, it will get the IR id of incoming event through IR server
//2- When one proxy wants to forward one incoming request to real object, it will use
**/
public class Server
{
    static ORB orb ;

    public static void main(String args[])
    {

      try
	{
            Properties props = System.getProperties();
	    props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	    props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
	    System.setProperties(props);

            //
            // Create ORB and BOA
            //
            orb = ORB.init(args, props);
	    BOA boa = ((com.ooc.CORBA.ORB)orb).BOA_init(args, props);

	    //
            // Set the concurrency model
            //
            com.ooc.CORBA.ORB.conc_model(
                com.ooc.CORBA.ORB.ConcModel.ConcModelThreaded);

            if(com.ooc.CORBA.BOA.conc_model() !=
               com.ooc.CORBA.BOA.ConcModel.ConcModelThreadPool)
            {
               System.out.println("Thereaed SETTTTTTTTTTTTTTTTTTT");
                com.ooc.CORBA.BOA.conc_model(
                    com.ooc.CORBA.BOA.ConcModel.ConcModelThreadPerRequest);
            }


	    //
	    // Create delegate object
	    //
	    if (args.length < 1){
	      System.out.println("Enter config file ");
	      System.exit(0);
	    }
	    
	     //satrt Interface Repository
             Process intRep = startIntRep();
 
	    String configFile = args[0];
	    System.out.println("Server: read config file");
		org.omg.CORBA.Object  conn=null;
		try{
			conn = new WebFlowContextImpl(configFile,orb, boa,intRep);
		}catch(WebFlow.NullPointerException e){
			System.out.println("WebFlow Server: got exc.:"+e);
		}
		catch(PropertyVetoException e){
			System.out.println("WebFlow Server: got exc.:"+e);
		}

	    System.out.println("Server: created WFServerImpl");
	    
	    //
          // Save reference as html
          //
          try
            {
                String ref = orb.object_to_string(conn);
                String refFile = "Hello.html";
                FileOutputStream file = new FileOutputStream(refFile);
                PrintWriter out = new PrintWriter(file);
                out.println("<applet codebase=\"classes\" " +
                            "code=\"hello/Client.class\" " +
                            "width=500 height=300>");
                out.println("<param name=ior value=\"" + ref + "\">");
                out.println("<param name=org.omg.CORBA.ORBClass " +
                            "value=com.ooc.CORBA.ORB>");
                out.println("<param name=org.omg.CORBA.ORBSingletonClass " +
                            "value=com.ooc.CORBA.ORBSingleton>");
                out.println("</applet>");
                out.flush();
                file.close();
            }
            catch(IOException ex)
            {
                System.err.println("Can't write to `" +
                                   ex.getMessage() + "'");
                System.exit(1);
            }
    

	    //
	    // Run implementation
	    //
	    WebFlowContextImpl impl = (WebFlowContextImpl)conn;
	    System.out.println("GATEWAY SERVER:exist:"+impl.non_existent);
	    if (impl.non_existent)
	      boa.impl_is_ready(null);
	    System.out.println("GATEWAY SERVER IS EXITING ....");

	    System.exit(0);
	}
	catch(SystemException ex)
	{
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
    }

public static Process startIntRep()
  {
	String ref=null ;
	printProcessOut ppo;
	org.omg.CORBA.Object IRobj=null;
	Process p=null;

	System.out.println("start interface Repository");
	String command = "irserv --ior";
	try{
	 p = Runtime.getRuntime().exec(command);
	 ppo = new printProcessOut(p);
     
	 ref = ppo.getIOROfProcess();
	 System.out.println("WebFlow server got IOR of IR:"+ref);
	 ppo.startProcess(); 
	}catch (Exception ex){
		 System.out.println("Error in starting ModuleFactory in Proxy:"+ex);
	}

	IRobj = orb.string_to_object(ref);
	System.out.println("WebFlow server connected to IR:"+IRobj);
	((com.ooc.CORBA.ORB)orb).add_initial_reference("InterfaceRepository", IRobj);
	System.out.println("WebFlow server connected to IR");

	return p;
 }	


public  static org.omg.CORBA.Object readIOR(org.omg.CORBA.ORB orb ,String fn)
{
    String ref = null;
    try
      {
		String refFile = fn;//"Hello.ref";
		FileInputStream file = new FileInputStream(refFile);
		BufferedReader in =
		new BufferedReader(new InputStreamReader(file));
		ref = in.readLine();
		file.close();
      }
    catch(IOException ex)
      {
            System.err.println("Can't read from `" +
                                   ex.getMessage() + "'");
			System.exit(1);
      }
 
    org.omg.CORBA.Object obj = orb.string_to_object(ref);
    return obj;
        
  }



}


