package WebFlow.xml; 

import WebFlow.*; 
import WebFlow.event.*; 
import WebFlow.gscript.*;
import org.omg.CORBA.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import java.net.*; 

public class ClientG{

public static String XmlInput;
public static String RSL;
public static String InstallRSL;

   public static void main(String args[])
   {
      configReader config ; 

      try
      {
         //  Create ORB
         ORB orb = ORB.init(args , new java.util.Properties()); 

         //  Connect to the master server


         if(args.length !=2) {
           System.out.println("Usage:");
           System.out.println("   WebFlow.JobService.ClientG url xml");
           System.out.println("     url - url to the master's IOR");
           System.out.println("     xml - xml file containg application descriptor");
           System.exit(1);
	 }    

         String masterURL = args[0] ; 

         XmlInput = args[1];
         File xmlfile = new File(XmlInput);
         if(!xmlfile.exists()) {
            System.out.println("file: "+XmlInput+" does not exist");
            System.out.println("Sorry. Quitting...");
            System.exit(1);
	 }
    
         String ref ; 
         org.omg.CORBA.Object obj = null ; 
         System.out.println(" masterURL : "+masterURL); 

         ref = getIORFromURL(masterURL); 

         System.out.println("REF: "+ref); 

         obj = orb.string_to_object(ref); 

         if(obj == null)
              throw new RuntimeException(); 

         WebFlowContext ws =  WebFlowContextHelper.narrow(obj);
         System.out.println("Client: got master "+ws);
  
         if(ws == null)
               throw new RuntimeException(); 
         
          org.omg.CORBA.Object p1 = ws.addNewModule("XmlServer"); 
          XmlServer parser = XmlServerHelper.narrow(p1);   

          if (parser.instantiateParser(XmlInput)) {

              String[] iHosts=parser.getInstalledHosts();
              if(iHosts.length<1) {
      System.out.println("this application is not installed anywhere");
              }
              else {   
      System.out.println("list of sites where this application is installed");
               for (int i=0; i<iHosts.length; i++) {
                   System.out.println(iHosts[i]);
	       } 
               System.out.println("select the first one...");
                 RSL=parser.getRSL(iHosts[0]);
                 if(RSL.indexOf("script:")>-1) {
                    System.out.println("There is a script to be generated");
                    System.out.println(RSL);
                    // instantiate the module and call its method 
             
                    org.omg.CORBA.Object p2 = ws.addNewModule("gScript"); 
                    gScript script = gScriptHelper.narrow(p2);   
                    script.createScript("/tmp/Gauss.scr","haupt",
                     "gaussian.inp","origin-haupt-1999.08.12.03111");
                    // I think it should be
                    // jobdir = script.createScript(scratch,user,inputfile);
                    // and job dir can be generated by the script itself;
                    // /tmp/Gauss.src can be samehow standardized, so I do not
                    // have to send it as a parameter?
                    // can the script learn who is the user?
                    // so only the name of the input file stays as argument
                    // is it general enough? Should be an aray?  
                    // submit this script!

		 }                            
                 else {
                    System.out.println("The RSL string is");
                    System.out.println(RSL);
		 }
	      }
    
  	  }

      } catch(COMM_FAILURE ex) {
        System.out.println("Command_Error: "+ex); 

        System.err.println(ex.getMessage()); 
        ex.printStackTrace(); 
        System.exit(1); 
       }  
   } 

   static public String getIORFromURL(String url) {

   System.out.println("Slave WebFlow is getting IOR from url:"+url); 
   String masterServerIOR =""; 
   String thisLine = null ; 

   // Open the URL for reading 
 
   try{
        URL u = new URL(url); 

        // now turn the URL into a DataInputStream

        try{
         DataInputStream theHTML = new DataInputStream(u.openStream());

          while((thisLine = theHTML.readLine()) != null){ 
             masterServerIOR += thisLine ; 
          } 
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
        }
     }
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
     }
    return masterServerIOR ; 
  }
}
