package WebFlow.xsl; 
import WebFlow.*; 
import WebFlow.event.*; 
import org.omg.CORBA.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import java.net.*; 
import java.util.*;

public class Client{

public static String XmlInput;
public static String RSL;
public static String InstallRSL;

   public static void main(String args[])
   {
      configReader config ; 

      try
      {
         //  Create ORB
         Properties props = System.getProperties();
         props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
         props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
         System.setProperties(props);

         ORB orb = ORB.init(args, props);

         //  Connect to the master server


         if(args.length !=2) {
           System.out.println("Usage:");
           System.out.println("   WebFlow.JobService.Client url xml");
           System.out.println("     url - url to the master's IOR");
           System.out.println("     xml - xml file containg application descriptor");
           System.exit(1);
	 }    

         String masterURL = args[0] ; 

         XmlInput = args[1];
         File xmlfile = new File(XmlInput);
         if(!xmlfile.exists()) {
            System.out.println("file: "+XmlInput+" does not exist");
            System.out.println("Sorry. Quitting...");
            System.exit(1);
	 }
    
         String ref ; 
         org.omg.CORBA.Object obj = null ; 
         System.out.println(" masterURL : "+masterURL); 

         ref = getIORFromURL(masterURL); 

         System.out.println("REF: "+ref); 

         obj = orb.string_to_object(ref); 

         if(obj == null)
              throw new RuntimeException(); 

         WebFlowContext ws =  WebFlowContextHelper.narrow(obj);
         System.out.println("Clinet: got master "+ws);
  
         if(ws == null)
               throw new RuntimeException(); 
         
          org.omg.CORBA.Object p1 = ws.addNewModule("XmlServer"); 
          XmlServer parser = XmlServerHelper.narrow(p1);   

          if (parser.instantiateParser(XmlInput)) {

               parser.testDOM();
               String hostname="osprey3.npac.syr.edu"; 
               System.out.println(hostname+": If installed, get RSL");
	       if(parser.isApplicationInstalled(hostname)){
                  RSL=parser.getRSL(hostname);
                  System.out.println(RSL);
	       } else {
		   if(parser.isApplicationInstallable(hostname)){
                      InstallRSL=parser.getInstallRSL(hostname);
                      System.out.println(InstallRSL);                      
                      parser.setApplicationInstalled(hostname);
                      RSL=parser.getRSL(hostname);
                      System.out.println(RSL);                                 
		   }
		   else {
                      System.out.println("Application is not installed,"+
                        " and it cannot be installed at this time ");
		   }
	       }
                       
               System.out.println("osprey4: Is installed? "
                +parser.isApplicationInstalled("osprey4.npac.syr.edu"));
               System.out.println("osprey5: Is installed? "
                +parser.isApplicationInstalled("osprey5.npac.syr.edu"));
               System.out.println("osprey6: Is installed? "
                +parser.isApplicationInstalled("osprey6.npac.syr.edu"));
               System.out.println("osprey7: Is installed? "
                +parser.isApplicationInstalled("osprey7.npac.syr.edu"));
               System.out.println("now test getInstalledHosts...");

               String[] iHosts=parser.getInstalledHosts();
               for (int i=0; i<iHosts.length; i++) {
                   System.out.println(iHosts[i]);
	       } 

	  }

      } catch(COMM_FAILURE ex) {
        System.out.println("Command_Error: "+ex); 

        System.err.println(ex.getMessage()); 
        ex.printStackTrace(); 
        System.exit(1); 
       }  
   } 

   static public String getIORFromURL(String url) {

   System.out.println("Slave WebFlow is getting IOR from url:"+url); 
   String masterServerIOR =""; 
   String thisLine = null ; 

   // Open the URL for reading 
 
   try{
        URL u = new URL(url); 

        // now turn the URL into a DataInputStream

        try{
         DataInputStream theHTML = new DataInputStream(u.openStream());

          while((thisLine = theHTML.readLine()) != null){ 
             masterServerIOR += thisLine ; 
          } 
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
        }
     }
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
     }
    return masterServerIOR ; 
  }
}
